Attribute VB_Name = "ModMain"
Option Explicit

Public Const AddinName = "CodeFolding"

Public VBInstance As VBIDE.VBE
Public Connect As Connect


Enum tFoldingTechnique
    RepositionCode = 0
    ExternalFile = 1 'NOT IMPLEMENTED
End Enum

Enum tFoldParams
    DontShow = 0
    ShowHint = 1
    ShowAll = 2
End Enum

Public Type tConfig
    TabCantSpaces As Long
    FoldingTechnique As tFoldingTechnique
    sFoldPrefix As String
    FoldParams As tFoldParams
    FoldedStorageStartMark As String
    FoldedStorageEndMark As String
    RegionStartMark As String
    RegionEndMark As String
    RegionHeader As String
    RegionFooter As String
    TmpUnfold As String
    TmpFold As String
    FoldedStorageHeader As String
    FoldedStorageFooter As String
    Iconset As Long
    sAutoFold As String
End Type

Public Config As tConfig


'==================================
'Load Configuration
'==================================
Public Sub LoadConfig()
Dim FontF$, FontSize&, FontCharset&
Dim s$

    Config.TabCantSpaces = Registry_Read("HKEY_CURRENT_USER\Software\Microsoft\VBA\Microsoft Visual Basic\", "TabWidth", 4)
    'Get IDE font
    FontF$ = Registry_Read("HKEY_CURRENT_USER\Software\Microsoft\VBA\Microsoft Visual Basic\", "FontFace", "Courier New")
    FontSize& = Registry_Read("HKEY_CURRENT_USER\Software\Microsoft\VBA\Microsoft Visual Basic\", "FontHeight", 10)
    FontCharset& = Registry_Read("HKEY_CURRENT_USER\Software\Microsoft\VBA\Microsoft Visual Basic\", "FontCharSet", 0)
    
    'Set it to the frmAddIn
    frmAddin.Font.Name = FontF
    frmAddin.Font.Size = FontSize&
    frmAddin.Font.Charset = FontCharset&

    Config.FoldingTechnique = tFoldingTechnique.RepositionCode
    Config.TmpUnfold = "'TMPUNFOLD:"
    Config.TmpFold = "'TMPFOLD:"
    Config.sAutoFold = " [AutoUnfold]"
    
    'Configurables
    Config.FoldParams = Val(GetSetting(App.Title, "Settings", "FoldParams", tFoldParams.ShowAll))
    Config.sFoldPrefix = GetSetting(App.Title, "Settings", "sFoldPrefix", "'FOLDED:")
  
    s$ = ""
    s$ = s$ & "'\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/" & vbCrLf
    s$ = s$ & "'  --- All folded content will be temporary put under this lines ---" & vbCrLf
    s$ = s$ & "'/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\"
    Config.FoldedStorageHeader = GetSetting(App.Title, "Settings", "FoldedStorageHeader", s$)
    
    Config.FoldedStorageStartMark = GetSetting(App.Title, "Settings", "FoldedStorageStartMark", "'CODEFOLD STORAGE:")
    Config.FoldedStorageEndMark = GetSetting(App.Title, "Settings", "FoldedStorageEndMark", "'CODEFOLD STORAGE END:")
    s$ = ""
    s$ = s$ & "'\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/" & vbCrLf
    s$ = s$ & "'--- If you're Subclassing: Move the CODEFOLD STORAGE up as needed ---" & vbCrLf
    s$ = s$ & "'/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\"
    Config.FoldedStorageFooter = GetSetting(App.Title, "Settings", "FoldedStorageFooter", s$)
    
    Config.RegionHeader = GetSetting(App.Title, "Settings", "RegionHeader", "///")
    Config.RegionStartMark = GetSetting(App.Title, "Settings", "RegionStartMark", "'#REGION:")
    Config.RegionEndMark = GetSetting(App.Title, "Settings", "RegionEndMark", "'#END REGION")
    Config.RegionFooter = GetSetting(App.Title, "Settings", "RegionFooter", "///")
 
    Config.Iconset = Val(GetSetting(App.Title, "Settings", "Iconset", 2))
 
End Sub

Public Sub SaveConfig()
    
    SaveSetting App.Title, "Settings", "FoldParams", CStr(Config.FoldParams)
    SaveSetting App.Title, "Settings", "sFoldPrefix", CStr(Config.sFoldPrefix)
    
    SaveSetting App.Title, "Settings", "FoldedStorageHeader", CStr(Config.FoldedStorageHeader)
    SaveSetting App.Title, "Settings", "FoldedStorageStartMark", CStr(Config.FoldedStorageStartMark)
    SaveSetting App.Title, "Settings", "FoldedStorageEndMark", CStr(Config.FoldedStorageEndMark)
    SaveSetting App.Title, "Settings", "FoldedStorageFooter", CStr(Config.FoldedStorageFooter)
    
    SaveSetting App.Title, "Settings", "RegionHeader", CStr(Config.RegionHeader)
    SaveSetting App.Title, "Settings", "RegionStartMark", CStr(Config.RegionStartMark)
    SaveSetting App.Title, "Settings", "RegionEndMark", CStr(Config.RegionEndMark)
    SaveSetting App.Title, "Settings", "RegionFooter", CStr(Config.RegionFooter)
   
    SaveSetting App.Title, "Settings", "Iconset", CStr(Config.Iconset)
 
End Sub

'======================================================
'Return true if sLookFor$ is not found in the code
'======================================================
Public Function IsUnique(ByRef VBCM As VBIDE.CodeModule, ByRef sLookFor$) As Boolean
On Error GoTo Err:
Dim lFoundLine&, Col&, En&, ColEnd&, bNotFound As Boolean
    If (sLookFor$ = "") Then Exit Function
    lFoundLine& = 1: Col = 1
    If Not (VBCM.Find(sLookFor$, lFoundLine&, Col&, -1, -1, True, True)) Then
        IsUnique = True
    End If
Err:
End Function

'====================================================
'Insert text on cursor position
'====================================================
Public Sub InsertLines(s$)
On Error GoTo Err
Dim lngStartLine As Long
Dim lngStartColumn As Long
Dim lngEndLine As Long
Dim lngEndColumn As Long
      ' Only add a new line if a code pane is present.
      If VBInstance.CodePanes.Count > 0 Then
          ' Retrieve the starting line of the
          ' selection in active code pane.
          VBInstance.ActiveCodePane.GetSelection lngStartLine, lngStartColumn, lngEndLine, lngEndColumn
          ' Add a line at the location that is
          ' retrieved in the GetSelection statement.
          VBInstance.ActiveCodePane.CodeModule.InsertLines lngStartLine, s$
      End If
    Exit Sub
Err:
    Debug.Print "InsertLines Err: " & Err.Description
End Sub
