Attribute VB_Name = "ModGeneric"
Option Explicit

' To global Hook keyboard
Private Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
Private Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long
Private Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Const WH_KEYBOARD = 2
Private Const WH_KEYBOARD_LL = 13
Private Const HC_ACTION = 0
Private Const HC_NOREMOVE = 3
 
Public Type KBDLLHOOKSTRUCT
    vkCode As Long
    scanCode As Long
    flags As Long
    time As Long
    dwExtraInfo As Long
End Type
 
Private hKbdHook As Long
Private bKbdIsHooked As Boolean
Private bHotKeytDown As Boolean 'to avoid repeating until key is up

' Disable CodeSmartHotkey
Private Declare Function RegisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Private Declare Function UnregisterHotkey Lib "user32" Alias "UnregisterHotKey" (ByVal hWnd As Long, ByVal id As Long) As Long
Const MOD_ALT = &H1
Const MOD_CONTROL = &H2
Const MOD_SHIFT = &H4


' Store WndProcs
Private Declare Function GetProp Lib "user32.dll" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Function SetProp Lib "user32.dll" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32.dll" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long

' Hooking
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal msg As Long, wParam As Any, lParam As Any) As Long

' Position Checking/Window handling
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetParent Lib "user32.dll" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function FindWindowEx Lib "user32.dll" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Sub SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Const HWND_TOPMOST              As Long = -1
Private Const HWND_NOTOPMOST            As Long = -2
Private Const SWP_NOSIZE                As Long = &H1
Private Const SWP_NOMOVE                As Long = &H2
Private Const SWP_NOZORDER              As Long = &H4
Private Const SWP_NOACTIVATE            As Long = &H10
Private Const SWP_FRAMECHANGED          As Long = &H20
Private Const SWP_SHOWWINDOW            As Long = &H40
Private Const SWP_HIDEWINDOW            As Long = &H80
Private Const SWP_ASYNCWINDOWPOS        As Long = &H4000




Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, ByVal nCmdShow As Long) As Long

'Private Declare Function SetWindowLong Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_EXSTYLE As Long = (-20)
Private Const GWL_STYLE As Long = (-16)
Public Enum eWindowStyle
    WS_OVERLAPPED = &H0
    WS_POPUP = &H80000000
    WS_CHILD = &H40000000
    WS_MINIMIZE = &H20000000
    WS_VISIBLE = &H10000000
    WS_DISABLED = &H8000000
    WS_CLIPSIBLINGS = &H4000000
    WS_CLIPCHILDREN = &H2000000
    WS_MAXIMIZE = &H1000000
    WS_CAPTION = &HC00000
    WS_BORDER = &H800000
    WS_DLGFRAME = &H400000
    WS_VSCROLL = &H200000
    WS_HSCROLL = &H100000
    WS_SYSMENU = &H80000
    WS_THICKFRAME = &H40000
    WS_GROUP = &H20000
    WS_TABSTOP = &H10000
    WS_MINIMIZEBOX = &H20000
    WS_MAXIMIZEBOX = &H10000
    WS_TILED = &H0
    WS_ICONIC = &H20000000
    WS_SIZEBOX = &H40000
    WS_OVERLAPPEDWINDOW = &HCF0000
    WS_POPUPWINDOW = &H80880000
End Enum

Public Enum eWindowStyleEx
    WS_EX_DLGMODALFRAME = &H1
    WS_EX_NOPARENTNOTIFY = &H4
    WS_EX_TOPMOST = &H8
    WS_EX_ACCEPTFILES = &H10
    WS_EX_TRANSPARENT = &H20
    WS_EX_MDICHILD = &H40
    WS_EX_TOOLWINDOW = &H80
    WS_EX_WINDOWEDGE = &H100
    WS_EX_CLIENTEDGE = &H200
    WS_EX_CONTEXTHELP = &H400
    WS_EX_RIGHT = &H1000
    WS_EX_LEFT = &H0
    WS_EX_RTLREADING = &H2000
    WS_EX_LTRREADING = &H0
    WS_EX_LEFTSCROLLBAR = &H4000
    WS_EX_RIGHTSCROLLBAR = &H0
    WS_EX_CONTROLPARENT = &H10000
    WS_EX_STATICEDGE = &H20000
    WS_EX_APPWINDOW = &H40000
    WS_EX_OVERLAPPEDWINDOW = &H300
    WS_EX_PALETTEWINDOW = &H188
    WS_EX_LAYERED = &H80000
    WS_EX_COMPOSITED = &H2000000
    WS_EX_NOACTIVATE = &H8000000
End Enum
' for OnTop
'Private Declare Function SetWindowPos Lib "User32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'Animating window
Private Declare Function AnimateWindow Lib "user32" (ByVal hWnd As Long, ByVal dwTime As Long, ByVal dwFlags As Long) As Long
Private Const AW_HOR_POSITIVE = &O1 ' Animate the window from left to right. This flag can be used with roll or slide animation It is ignored when used with the AW_CENTER flag.
Private Const AW_HOR_NEGATIVE = &H2 ' Animate the window from right to left. This flag can be used with roll or slide animation. It is ignored when used with the AW_CENTER flag.
Private Const AW_VER_POSITIVE = &H4 ' Animate the window from top to bottom. This flag can be used with roll or slide animation. It is ignored when used with the AW_CENTER flag.
Private Const AW_VER_NEGATIVE = &H8 ' Animate the window from bottom to top. This flag can be used with roll or slide animation. It is ignored when used with the AW_CENTER flag.
Private Const AW_CENTER = &H10 ' Makes the window appear to collapse inward if the AW_HIDE flag is used or expand outward if the AW_HIDE flag is not used.
Private Const AW_HIDE = &H10000 ' Hides the window. By default the window is shown.
Private Const AW_ACTIVATE = &H20000 ' Activates the window. Do'not use this flag with AW_HIDE.
Private Const AW_SLIDE = &H40000 ' Uses slide animation. By default, roll animation is used. This flag is ignored when used with the AW_CENTER flag.
Private Const AW_BLEND = &H80000 ' Uses a fade effect. This flag can be used only if hwnd is a top-level window.
'Animating window

'ScreenDPI
Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetDeviceCaps Lib "gdi32.dll" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const LOGPIXELSX As Long = 88
Public FDPI! 'store Dpi ratio pre calculated
'ScreenDPI

'--ApiWait---- = like doevents but dont use 100% cpu
Private Type FileTime
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Const WAIT_ABANDONED& = &H80&
Private Const WAIT_ABANDONED_0& = &H80&
Private Const WAIT_FAILED& = -1&
Private Const WAIT_IO_COMPLETION& = &HC0&
Private Const WAIT_OBJECT_0& = 0
Private Const WAIT_OBJECT_1& = 1
Private Const WAIT_TIMEOUT& = &H102&
Private Const INFINITE = &HFFFF
Private Const ERROR_ALREADY_EXISTS = 183&
Private Const QS_HOTKEY& = &H80
Private Const QS_KEY& = &H1
Private Const QS_MOUSEBUTTON& = &H4
Private Const QS_MOUSEMOVE& = &H2
Private Const QS_PAINT& = &H20
Private Const QS_POSTMESSAGE& = &H8
Private Const QS_SENDMESSAGE& = &H40
Private Const QS_TIMER& = &H10
Private Const QS_MOUSE& = (QS_MOUSEMOVE Or QS_MOUSEBUTTON)
Private Const QS_INPUT& = (QS_MOUSE Or QS_KEY)
Private Const QS_ALLEVENTS& = (QS_INPUT Or QS_POSTMESSAGE Or QS_TIMER Or QS_PAINT Or QS_HOTKEY)
Private Const QS_ALLINPUT& = (QS_SENDMESSAGE Or QS_PAINT Or QS_TIMER Or QS_POSTMESSAGE _
                                              Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)


Private Declare Function CreateWaitableTimer Lib "kernel32" Alias "CreateWaitableTimerA" (ByVal lpSemaphoreAttributes As Long, _
    ByVal bManualReset As Long, ByVal lpName As String) As Long
Private Declare Function OpenWaitableTimer Lib "kernel32" Alias "OpenWaitableTimerA" (ByVal dwDesiredAccess As Long, _
    ByVal bInheritHandle As Long, ByVal lpName As String) As Long
Private Declare Function SetWaitableTimer Lib "kernel32" (ByVal hTimer As Long, lpDueTime As FileTime, ByVal lPeriod As Long, _
    ByVal pfnCompletionRoutine As Long, ByVal lpArgToCompletionRoutine As Long, ByVal fResume As Long) As Long
Private Declare Function CancelWaitableTimer Lib "kernel32" (ByVal hTimer As Long)
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Private Declare Function MsgWaitForMultipleObjects Lib "user32" (ByVal nCount As Long, pHandles As Long, _
    ByVal fWaitAll As Long, ByVal dwMilliseconds As Long, ByVal dwWakeMask As Long) As Long
'--- ApiWait --

Private Const GWL_WNDPROC = -4
Private Const WM_MOUSEWHEEL = &H20A
Private Const CB_GETDROPPEDSTATE = &H157

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Declare Function GetCaretPos Lib "user32" (lpPoint As POINTAPI) As Long

'======================================
' Pone en "ALWAYS ON TOP" una ventana
'======================================
Public Sub pOnTop(lHwnd&, state As Boolean, Show As Boolean)
Dim v&

    v = SWP_NOSIZE Or SWP_NOMOVE Or SWP_NOACTIVATE
    If (Show) Then
        v = v Or SWP_SHOWWINDOW
    Else
        v = v Or SWP_HIDEWINDOW
    End If
    If (state = False) Then
        Call SetWindowPos(lHwnd&, HWND_NOTOPMOST, 0, 0, 0, 0, v)
    Else
        Call SetWindowPos(lHwnd&, HWND_TOPMOST, 0, 0, 0, 0, v)
    End If
End Sub

'===============================================
'Tell a window its style changed
'to be called after a SetWindowLong when needed
'===============================================
Public Function UpdateWindowStyle(lHwnd&)
    SetWindowPos lHwnd&, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED
End Function

Public Function pGetParent(ByRef hWnd As Long) As Long
    pGetParent = GetParent(hWnd)
End Function
'if hWndNewParent=0 set Parent to Desktop
Public Function pSetParent(ByRef hWndChild As Long, Optional ByVal hWndNewParent As Long = 0) As Long
    If (hWndNewParent = 0) Then hWndNewParent = GetDesktopWindow()
    pSetParent = SetParent(hWndChild, hWndNewParent)
End Function

'====================================================
'Set a window to selecteds parents
'====================================================
'0=Desktop
'1=VBIDE
'2=MDI (code editor)
Public Function SetWindowParentTo(WinhWnd&, SetTo&) As Long
Dim DestHWnd&, MainhWnd&

    Select Case SetTo&
    Case 0 ' Desktop
        DestHWnd& = 0
    Case 1 ' VB6 Ide
        DestHWnd& = VBInstance.MainWindow.hWnd
    Case 2
        MainhWnd = VBInstance.MainWindow.hWnd
        DestHWnd& = FindWindowEx(MainhWnd, 0, "MDIClient", vbNullString)

        'If (BDEBUG) Then sLog ("SetWindowParentTo:" & Hex(DestHWnd&))
    End Select
    
    pSetParent WinhWnd&, DestHWnd&
    SetWindowParentTo = DestHWnd&
End Function

'=============================================================
'Try to get a good position for the Tooltip anchored
'below the declaration combo
'=============================================================
'This is just a default position. User may overrided moving it
'on config
Public Sub CalcVbMDIRect(ByRef RefRect As RECT)
Dim MDI&, CboGeneral&, CboDeclarations&, hMain&
Dim Child&
Dim r As RECT
Dim p As POINTAPI
Dim CboH&, cboW&


    'Try to find the MDI editor
    hMain& = VBInstance.MainWindow.hWnd
    MDI& = FindWindowEx(hMain, 0, "MDIClient", vbNullString)
    
    'Try to get the first open document
    Child& = FindWindowEx(MDI&, 0, vbNullString, vbNullString)
    If (Child& <> 0) Then
        'Then go through the (general) and get the (declaration) cbo
        CboGeneral& = FindWindowEx(Child&, 0, "ComboBox", vbNullString)
        CboDeclarations& = FindWindowEx(Child&, CboGeneral&, "ComboBox", vbNullString)
    
    End If
    
    'If we found the CBO calculate position below it
    If (CboDeclarations& <> 0) Then
        GetWindowRect CboDeclarations&, r
        p.x = r.Left: p.y = r.Top
        ScreenToClient hMain&, p
        CboH = p.y + (r.Bottom - r.Top)
        RefRect.Top = CboH + (4 * FDPI)
        RefRect.Left = p.x
        RefRect.Right = (r.Right - r.Left) - (10 * FDPI)
        RefRect.Bottom = 0
    Else
        'Try to guess from MDI
        GetWindowRect MDI&, r
        p.x = r.Left: p.y = r.Top
        ScreenToClient hMain&, p
        RefRect.Top = p.y + (53 * FDPI)
        RefRect.Left = ((r.Right - r.Left) / 2) + (48 * FDPI)
        RefRect.Right = (r.Right - r.Left) - (30 * FDPI)
    End If
    
End Sub


Public Sub AnimWindow(hWnd&, Anim&)
Dim t&, F&
    Select Case Anim
    Case 0
        t = 120
        F& = AW_VER_NEGATIVE + AW_HIDE + AW_SLIDE
    Case 1
        t = 80
        F& = AW_VER_POSITIVE + AW_SLIDE
    End Select
    
    AnimateWindow hWnd&, t&, F&
End Sub

'--ApiWait---- = like doevents but dont use 100% cpu
Public Sub ApiWait(lNumberOfMiliseconds As Double)
Dim FT As FileTime
Dim lBusy As Long
Dim lRet As Long
Dim dblDelay As Double
Dim dblDelayLow As Double
Dim dblUnits As Double
Dim hTimer As Long
    
  ' Sanity check
  If Not (Environ("OS") = "Windows_NT") Then Exit Sub
    
    
    hTimer = CreateWaitableTimer(0, True, App.EXEName & "Timer")


    If Err.LastDllError = ERROR_ALREADY_EXISTS Then
        ' If the timer already exists, it does n
        '     ot hurt to open it
        ' as long as the person who is trying to
        '     open it has the
        ' proper access rights.
    Else
        FT.dwLowDateTime = -1
        FT.dwHighDateTime = -1
        lRet = SetWaitableTimer(hTimer, FT, 0, 0, 0, 0)
    End If

    ' Convert the Units to nanoseconds.
    dblUnits = CDbl(&H10000) * CDbl(&H10000)
    dblDelay = CDbl(lNumberOfMiliseconds) * 10000
    ' By setting the high/low time to a nega
    '     tive number, it tells
    ' the Wait (in SetWaitableTimer) to use
    '     an offset time as
    ' opposed to a hardcoded time. If it wer
    '     e positive, it would
    ' try to convert the value to GMT.
    FT.dwHighDateTime = -CLng(dblDelay / dblUnits) - 1
    dblDelayLow = -dblUnits * (dblDelay / dblUnits - _
    Fix(dblDelay / dblUnits))

    If dblDelayLow < CDbl(&H80000000) Then
        ' &H80000000 is MAX_LONG, so you are jus
        '     t making sure
        ' that you don't overflow when you try t
        '     o stick it into
        ' the FILETIME structure.
        dblDelayLow = dblUnits + dblDelayLow
    End If

    FT.dwLowDateTime = CLng(dblDelayLow)
    lRet = SetWaitableTimer(hTimer, FT, 0, 0, 0, False)

    Do
        ' QS_ALLINPUT means that MsgWaitForMulti
        '     pleObjects will
        ' return every time the thread in which
        '     it is running gets
        ' a message. If you wanted to handle mes
        '     sages in here you could,
        ' but by calling Doevents you are lettin
        '     g DefWindowProc
        ' do its normal windows message handling
        '     ---Like DDE, etc.
        lBusy = MsgWaitForMultipleObjects(1, hTimer, False, _
        INFINITE, QS_ALLINPUT&)
        
        DoEvents
        Loop Until lBusy = WAIT_OBJECT_0

        ' Close the handles when you are done wi
        '     th them.
        CloseHandle hTimer
    End Sub
'--ApiWait----

'=================================================================
'Set Size of a child window relative to the parent
'=================================================================
Public Sub SetChildSize(ByRef lHwnd&, ByRef Width&, ByRef Height&)
    SetWindowPos lHwnd&, 0, 0, 0, Width&, Height&, SWP_NOMOVE + SWP_NOACTIVATE + SWP_ASYNCWINDOWPOS
End Sub

'=================================================================
'Set Position of a child window relative to the parent
'=================================================================
Public Sub SetChildPos(ByRef lHwnd&, ByRef Left&, ByRef Top&)
    SetWindowPos lHwnd&, 0, Left&, Top&, 0, 0, SWP_NOSIZE + SWP_NOACTIVATE + SWP_ASYNCWINDOWPOS
End Sub

'=================================================================
'Set Position and Size of a child window relative to the parent
'=================================================================
Public Sub SetChildRect(ByRef lHwnd&, ByRef r As RECT)
    SetWindowPos lHwnd&, 0, r.Left, r.Top, r.Right, r.Bottom, SWP_NOACTIVATE + SWP_ASYNCWINDOWPOS
End Sub

'=================================================================
'Get top,left,W,H of a child window relative to the parent
'To be used with SetWindowPos (Rect version)
'=================================================================
Public Sub GetChildRect(ByRef lHwnd&, ByRef rRect As RECT)
On Error GoTo Err:
Dim r As RECT
Dim hParent&
Dim x&, y&
    
    GetWindowRect lHwnd, r
    Dim p As POINTAPI
    p.x = r.Left
    p.y = r.Top
    ScreenToClient VBInstance.MainWindow.hWnd, p
    GetClientRect lHwnd, r
    
    rRect.Left = p.x
    rRect.Top = p.y
    rRect.Right = r.Right
    rRect.Bottom = r.Bottom
Err:
End Sub

Public Sub GetWinRect(ByRef lHwnd&, ByRef rRect As RECT)
On Error GoTo Err:
    GetWindowRect lHwnd, rRect
Err:
End Sub

Public Sub ShowWindowWithoutFocus2(lWnd&, LeftPx&, TopPx&)
    SetWindowPos lWnd&, HWND_TOPMOST, LeftPx&, TopPx&, 0, 0, SWP_SHOWWINDOW Or SWP_NOSIZE Or SWP_NOACTIVATE
End Sub

Public Sub ShowWindowWithoutFocus(lWnd&)
    ShowWindow lWnd&, 8 '4 '8=SW_SHOWNA , 4=SW_SHOWNOACTIVATE
End Sub

'==============================================================
'Apply window style updates
'Return old style
'==============================================================
Public Function pSetWindowLong(ByVal lHwnd As Long, ByVal Flag As Long, Optional ByVal removeFlag As Boolean = False, Optional ByVal useExtendedStyle As Boolean = False, Optional InstantUpdate As Boolean, Optional ByVal overrideEntireLong As Boolean = False) As Long
Dim nIndex As Long, curStyle As Long
        
    If useExtendedStyle Then
        nIndex = GWL_EXSTYLE
    Else
        nIndex = GWL_STYLE
    End If
    
    curStyle = GetWindowLong(lHwnd, nIndex)
    
    If overrideEntireLong Then
        SetWindowLong lHwnd, nIndex, Flag
    Else
        If removeFlag Then
            SetWindowLong lHwnd, nIndex, curStyle And (Not Flag)
        Else
            SetWindowLong lHwnd, nIndex, curStyle Or Flag
        End If
    End If
    
    'For some reason dont work properly without the DoEvents if needed to move or operate the coordinates after we called it
    If (InstantUpdate) Then UpdateWindowStyle lHwnd: DoEvents
    
    pSetWindowLong = curStyle
    
End Function

'==============================================================
'Disable hotkeys used in VBIDE
'==============================================================
'I defined it as a global hook cause it was the only way I
'was able to make it work. Hooking directly to the hWnd or
'trying to unregister it dosnt work for some reason.
Public Function RegisterHotkeys() As Boolean
On Error Resume Next
'Dim cbpop As CommandBarPopup
    
    'Ensure Hook only once
    If Not (bKbdIsHooked) Then
        bKbdIsHooked = True
        hKbdHook = SetWindowsHookEx(WH_KEYBOARD_LL, AddressOf LowLevelKeyboardProc, App.hInstance, 0)
    End If
    
    
'Tried this way...didnt worked :(  so the only workarround was to install a global keyhook
'wich I tried to avoid
'    'Disable CTRL+Q from Code Smart if active
'    For Each cbpop In VBInstance.CommandBars.Item(1).Controls
'        'Debug.Print cbpop.caption & " Err:" & Err.Number
'        If (cbpop.caption = "&CodeSMART") Then
'            RegisterHotKey 0, &HBFFF&, MOD_CONTROL, vbKeyQ
'        End If
'    Next
'
'    'Disable CTRL+D from VB6 (add file)
'    RegisterHotKey &H14151C, &HBFFE&, MOD_CONTROL, vbKeyD
'
'    'Disable CTRL+SHIFT+UP/DOWN from VB6
'    RegisterHotKey 0, &HBFFD&, MOD_CONTROL + MOD_SHIFT, vbKeyUp
'    RegisterHotKey 0, &HBFFC&, MOD_CONTROL + MOD_SHIFT, vbKeyDown

End Function

Public Sub UnregisterHotkeys()
On Error Resume Next
    If (bKbdIsHooked) Then
        UnhookWindowsHookEx hKbdHook
        bKbdIsHooked = False
    End If
    
'    Call UnregisterHotkey(0, &HBFFF&)
'    Call UnregisterHotkey(0, &HBFFE&)
'    Call UnregisterHotkey(0, &HBFFD&)
'    Call UnregisterHotkey(0, &HBFFC&)
End Sub

'Public Function LowLevelKeyboardProc(ByVal uCode As Long, ByVal wParam As Long, lParam As Long) As Long
Public Function LowLevelKeyboardProc(ByVal uCode As Long, ByVal wParam As Long, Hookstruct As KBDLLHOOKSTRUCT) As Long
On Error GoTo Err
Dim KeyCtrl As Integer, KeyShift As Integer, ActivW As Long
Const KEY_DOWN = &H8000

    If Not (Config.EnableHotkeys) Then
        LowLevelKeyboardProc = CallNextHookEx(hKbdHook, uCode, wParam, Hookstruct)
        Exit Function
    End If
    
    'Detect if we got the focus else dont process the keys
    ActivW = GetForegroundWindow()
    'If (BDEBUG) Then sLog " AW: " & ActivW & " Main: " & MainWindowhwnd
    If (ActivW <> MainWindowhwnd) Then
        If (bHotKeytDown) Then bHotKeytDown = False
        LowLevelKeyboardProc = CallNextHookEx(hKbdHook, uCode, wParam, Hookstruct)
        Exit Function
    End If
    
    'Read keys 2 times
    '1st time empty the buffer, 2nd read the actual state
    KeyCtrl = GetAsyncKeyState(KeyCodeConstants.vbKeyControl): KeyCtrl = GetAsyncKeyState(KeyCodeConstants.vbKeyControl)
    
    If uCode >= 0 Then
        
        'Debug.Print ">K: " & Hex(Hookstruct.vkCode) & ", Flags: " & Hex(Hookstruct.flags) & " AW: " & ActivW
    
        If (Hookstruct.vkCode = &H44) And (Hookstruct.flags = &H80) Then
            KeyCtrl = KeyCtrl
        End If
        
        Select Case Hookstruct.vkCode
        Case KeyCodeConstants.vbKeyD
            ' CTRL+D
            If (KeyCtrl And KEY_DOWN < 0) Then
                If Not (bHotKeytDown) Then
                    bHotKeytDown = True
                    frmAddIn.TimHotkeys.Tag = "D": frmAddIn.TimHotkeys.Enabled = True
                ElseIf (Hookstruct.flags = &H80) Then
                    bHotKeytDown = False
                End If
                LowLevelKeyboardProc = 1: Exit Function
            End If
                        
        ' CTRL+Q
        Case KeyCodeConstants.vbKeyQ
            If (KeyCtrl And KEY_DOWN < 0) Then
                If Not (bHotKeytDown) Then
                    bHotKeytDown = True
                    frmAddIn.TimHotkeys.Tag = "Q": frmAddIn.TimHotkeys.Enabled = True
                ElseIf (Hookstruct.flags = &H80) Then
                    bHotKeytDown = False
                End If
                LowLevelKeyboardProc = 1: Exit Function
            End If

        ' CTRL+SHIFT+UP
        Case KeyCodeConstants.vbKeyUp
            KeyShift = GetAsyncKeyState(KeyCodeConstants.vbKeyShift): KeyShift = GetAsyncKeyState(KeyCodeConstants.vbKeyShift)
            If (KeyCtrl And KEY_DOWN < 0) Then
                If (KeyShift And KEY_DOWN < 0) Then
                    If Not (bHotKeytDown) Then
                        bHotKeytDown = True
                        frmAddIn.TimHotkeys.Tag = "MU": frmAddIn.TimHotkeys.Enabled = True
                    ElseIf (Hookstruct.flags >= &H80) Then
                        bHotKeytDown = False
                    End If
                    LowLevelKeyboardProc = 1: Exit Function
                End If
            End If

        ' CTRL+SHIFT+DOWN
        Case KeyCodeConstants.vbKeyDown
            KeyShift = GetAsyncKeyState(KeyCodeConstants.vbKeyShift): KeyShift = GetAsyncKeyState(KeyCodeConstants.vbKeyShift)
            If (KeyCtrl And KEY_DOWN < 0) Then
                If (KeyShift And KEY_DOWN < 0) Then
                    If Not (bHotKeytDown) Then
                        bHotKeytDown = True
                        frmAddIn.TimHotkeys.Tag = "MD": frmAddIn.TimHotkeys.Enabled = True
                    ElseIf (Hookstruct.flags >= &H80) Then
                        bHotKeytDown = False
                    End If
                    LowLevelKeyboardProc = 1: Exit Function
                End If
            End If
        End Select

    End If
        
    'If (bHotKeytDown) Then bHotKeytDown = False
    
    LowLevelKeyboardProc = CallNextHookEx(hKbdHook, uCode, wParam, Hookstruct)
    
    Exit Function
Err:
    If (BDEBUG) Then sLog "LowLevelKeyboardProc Err: " & Err.Description
End Function


'===================================================
'Count the number of spaces and tabs at the
'beggining of a string
'===================================================
Public Function CountStartingSpacesTabs(ByVal s$) As Long
On Error GoTo Err:
Dim i&
    
    If (s$ = "") Then CountStartingSpacesTabs = 0: Exit Function
    i = 0
    s$ = Replace(s$, vbTab, String$(Config.TabCantSpaces, " "))
    Do While (Left(s$, 1) = " ")
        i = i + 1
        s = Mid$(s$, 2)
    Loop
    CountStartingSpacesTabs = i
    Exit Function
Err:
    If (BDEBUG) Then sLog "CountStartingSpacesTabs Err: " & Err.Description
End Function

'By Leandro Ascierto
Public Property Get ScreenDPI() As Single
    Dim hdc As Long: hdc = GetDC(0)
    ScreenDPI = GetDeviceCaps(hdc, 118) / (Screen.Width / Screen.TwipsPerPixelX)
    ReleaseDC 0, hdc
End Property

'==================================
' devuelve el path de un archivo
'==================================
Public Function sExtraePath(ByVal archivo As String) As String
Dim c$
    If (InStr(archivo, "/") > 0) Then
        c$ = "/"
    ElseIf (InStr(archivo, "\") > 0) Then
        c$ = "\"
    Else
        'no tiene path, solo es el nombre del archivo
        sExtraePath = ""
        Exit Function
    End If
  sExtraePath = Mid(archivo, 1, (Len(archivo) - InStr(1, StrReverse(archivo), c$)) + 1)
End Function

'==================================
' devuelve la extension de un archivo
'==================================
Public Function sExtraeFileExtension(archivo As String) As String
Dim x As Long
    x = InStrRev(archivo, ".")
    sExtraeFileExtension = Right(archivo, Len(archivo) - x)
End Function

'==================================
' devuelve el nombre de un archivo sin la extension
'==================================
Public Function sExtraeFilenameSinExtension(archivo As String) As String
On Error GoTo Err
Dim x As Long
    x = InStrRev(archivo, ".")
    sExtraeFilenameSinExtension = Left(archivo, x - 1)
    Exit Function
Err:
    sExtraeFilenameSinExtension = archivo
End Function

'==================================
' devuelve el nombre de un archivo
'==================================
Public Function sExtraeFilename(ByVal archivo As String) As String
  archivo = Replace(archivo, "/", "\")
  sExtraeFilename = Right(archivo, Len(archivo) - Len(sExtraePath(archivo)))
End Function



'================================================
'Un/Comment all lines in Block
'================================================
Public Sub SmartCommentBlock()
On Error GoTo Err:
Dim tLines$(), i&, bRemove As Boolean, aux$, lpos&, FirstPos&
Dim VBCM As VBIDE.CodeModule, pre$, Pos$
Dim lngStartLine&, lngEndLine&, lngStartColumn&, lngEndColumn&

    Set VBCM = VBInstance.ActiveCodePane.CodeModule
    
    'Get cursor position
    VBInstance.ActiveCodePane.GetSelection lngStartLine, lngStartColumn, lngEndLine, lngEndColumn
    'Fix line not fully selected
    If (lngEndColumn = 1) And (lngStartLine <> lngEndLine) Then lngEndLine = lngEndLine - 1
    'Get all the lines
    tLines$ = Split(VBCM.Lines(lngStartLine, (lngEndLine - lngStartLine) + 1), vbCrLf)

    'Exit on empty lines
    If (UBound(tLines$) < 0) Then Exit Sub
    
    'Detect if we need to add or remove comment
    If (Left$(Trim$(tLines$(0)), 1) = "'") Then bRemove = True

    For i = lngStartLine To lngEndLine
        aux$ = tLines$(i - lngStartLine)
        lpos& = CountStartingSpacesTabs(aux$)
        If (bRemove) Then
            'skip empty lines
            If (aux$ <> "") Then
                'Check if line got ' as first text
                If (Mid$(aux$, lpos + 1, 1) = "'") Then
                    'Remove it
                    pre$ = Left$(aux$, lpos)
                    Pos$ = Mid$(aux$, lpos + 2)
                    aux$ = pre$ & Pos$
                    VBCM.ReplaceLine i, aux$
                End If
            End If
        Else
            'Add comment
            
            'Keep the beginning of text of the first comment line
            If (i = lngStartLine) Then
                FirstPos& = lpos&
            Else
                'Try to put a comment character in the same column for every other line
                'we check if the number of spaces at the begging of the other lines (lpos)
                'is bigger than the first=> split there
                If (lpos > FirstPos) Then lpos = FirstPos
            End If
            pre$ = Left$(aux$, lpos)
            Pos$ = Mid$(aux$, lpos + 1)
            aux$ = pre$ & "'" & Pos$
            VBCM.ReplaceLine i, aux$
        End If
    
    Next i
    
    'Set selection to the new block position
    VBInstance.ActiveCodePane.SetSelection lngStartLine, 1, lngEndLine, 999
    
    Exit Sub
Err:
    If (BDEBUG) Then sLog "SmartCommentBlock Err: " & Err.Description
End Sub

'================================================
'Duplicate selected lines
'================================================
Public Sub DuplicateLines()
On Error GoTo Err:
Dim tLines$
Dim lngStartLine&, lngEndLine&, lngStartColumn&, lngEndColumn&
Dim VBCM As VBIDE.CodeModule
    
    Set VBCM = VBInstance.ActiveCodePane.CodeModule
    
    'insert all lines in 1 go so it only use 1 undo step
    'VBCM.InsertLines lngEndLine + 1, VBCM.Lines(lngStartLine, (lngEndLine - lngStartLine))
    
    'Get cursor position
    VBInstance.ActiveCodePane.GetSelection lngStartLine, lngStartColumn, lngEndLine, lngEndColumn
    'Fix line not fully selected
    If (lngEndColumn = 1) And (lngStartLine <> lngEndLine) Then lngEndLine = lngEndLine - 1
    
    'Get the lines
    tLines$ = VBCM.Lines(lngStartLine, (lngEndLine - lngStartLine) + 1)
    VBCM.InsertLines lngEndLine& + 1, tLines$
    
    'Set selection to the new block position
    VBInstance.ActiveCodePane.SetSelection lngStartLine, 1, lngEndLine, 999

    Exit Sub
Err:
    If (BDEBUG) Then sLog "DuplicateLines Err: " & Err.Description
End Sub

'===========================================
'Move text lines
'===========================================
Public Sub moveBlockLines(MoveUp As Boolean)
On Error GoTo Err:
Dim tLines$, laux&
Dim VBCM As VBIDE.CodeModule
Dim lngStartLine&, lngEndLine&, lngStartColumn&, lngEndColumn&
    
    Set VBCM = VBInstance.ActiveCodePane.CodeModule
    
    'Get cursor position
    VBInstance.ActiveCodePane.GetSelection lngStartLine, lngStartColumn, lngEndLine, lngEndColumn
    'Fix line not fully selected
    If (lngEndColumn = 1) And (lngStartLine <> lngEndLine) Then lngEndLine = lngEndLine - 1
    'Get the lines
    tLines$ = VBCM.Lines(lngStartLine, (lngEndLine - lngStartLine) + 1)
    'delete the lines
    VBCM.DeleteLines lngStartLine, (lngEndLine - lngStartLine) + 1
    
    If (MoveUp) Then
        laux = -1
    Else
        laux = 1
    End If
    
    'insert all lines in shifted position
    VBCM.InsertLines lngStartLine + laux, tLines$
    'Set selection to the new block position
    VBInstance.ActiveCodePane.SetSelection lngStartLine + laux, 1, lngEndLine + laux, 999

    Exit Sub
Err:
    'If (BDEBUG) Then sLog "moveBlockLines Err: " & Err.Description
End Sub


Public Function Registry_Read(Key_Path$, Key_Name$, Optional DefaultValue As Variant = "") As Variant
On Error GoTo Def:
    If (Right$(Key_Path$, 1) <> "\") Then Key_Path$ = Key_Path$ & "\"
    Dim Registry As Object
    Set Registry = CreateObject("WScript.Shell")
    Registry_Read = Registry.RegRead(Key_Path & Key_Name)
    Exit Function
Def:
    Registry_Read = DefaultValue
End Function

Public Sub Registry_Write(Key_Path As String, Key_Name As String, Key_Value As Variant, Optional Key_Type As String = "REG_SZ")
On Error Resume Next
    
    'Key Type list (Use within string, ex. "
    '     REG_DWORD")
    '----------------
    
    'REG_BINARY - This type stores the value
    '     as raw binary data. Most hardware compon
    '     ent information is stored as binary data
    '     , and can be displayed in an editor in h
    '     exadecimal format.
    'REG_DWORD - This type represents the da
    '     ta by a four byte number and is commonly
    '     used for boolean values, such as "0" is
    '     disabled and "1" is enabled. Additionall
    '     y many parameters for device driver and
    '     services are this type, and can be displ
    '     ayed in REGEDT32 in binary, hexadecimal
    '     and decimal format, or in REGEDIT in hex
    '     adecimal and decimal format.
    'REG_EXPAND_SZ - This type is an expanda
    '     ble data string that is string containin
    '     g a variable to be replaced when called
    '     by an application. For example, for the
    '     following value, the string "%SystemRoot
    '     %" will replaced by the actual location
    '     of the directory containing the Windows
    '     NT system files. (This type is only avai
    '     lable using an advanced registry editor
    '     such as REGEDT32)
    'REG_MULTI_SZ - This type is a multiple
    '     string used to represent values that con
    '     tain lists or multiple values, each entr
    '     y is separated by a NULL character. (Thi
    '     s type is only available using an advanc
    '     ed registry editor such as REGEDT32)
    'REG_SZ - This type is a standard string
    '     , used to represent human readable text
    '     values.
    
    'Other data types not available through
    '     the standard registry editors include:
    
    'REG_DWORD_LITTLE_ENDIAN - A 32-bit numb
    '     er in little-endian format.
    'REG_DWORD_BIG_ENDIAN - A 32-bit number
    '     in big-endian format.
    'REG_LINK - A Unicode symbolic link. Use
    '     d internally; applications should not us
    '     e this type.
    'REG_NONE - No defined value type.
    'REG_QWORD - A 64-bit number.
    'REG_QWORD_LITTLE_ENDIAN - A 64-bit numb
    '     er in little-endian format.
    'REG_RESOURCE_LIST - A device-driver res
    '     ource list.
    Dim Registry As Object
    Dim Registry_Value As Variant
    
    Set Registry = CreateObject("WScript.Shell")
    'Registry_Value = Registry_Read(Key_Path, Key_Name, "")
    
    If Key_Type = "" Then
        'REG_SZ is the default.
        Registry.RegWrite Key_Path & Key_Name, Key_Value
    Else
        Registry.RegWrite Key_Path & Key_Name, Key_Value, Key_Type
    End If
    
End Sub



'NOT USED -----------
'
'Private Function GetForm(ByVal hWnd As Long) As Form
'  For Each GetForm In Forms
'    If GetForm.hWnd = hWnd Then Exit Function
'  Next GetForm
'  Set GetForm = Nothing
'End Function
'
'Public Function InIDE() As Boolean
'    InIDE = CBool(App.LogMode = 0)
'End Function
'
'
'
'Private Sub RectClone(ByRef O As RECT, ByRef D As RECT)
'    D.Left = O.Left
'    D.Bottom = O.Bottom
'    D.Right = O.Right
'    D.Top = O.Top
'End Sub
'
''Copy A to B and B to A
'Private Sub RectSwap(ByRef A As RECT, ByRef B As RECT)
'Dim raux As RECT
'    RectClone A, raux
'    RectClone B, A
'    RectClone raux, B
'End Sub
'

