Attribute VB_Name = "ModMain"
Option Explicit

Public Const BDEBUG = False 'Print debug message to console
Public Const AddinName = "Comments + Highlight + Extra Hotkeys"

Public VBInstance As VBIDE.VBE
Public Connect As Connect

Public Enum tScopeType
    tpPrivate = 0
    tpPublic = 1
    tpGlobal = 2
End Enum

Public Enum tDataOrigin
    tpMethod = 0
    tpLocal = 1
    tpTypelib = 2
    tpVariables = 3
End Enum

Public Type typeCheck
    LastCheckedModule As String 'To detect changes on modules
    LastTyped As String 'To detect changes on typed text (will not be afffected by parameters (a,b,c..
    bLastChecked As Boolean ' user stop typing but we still have not checked the text
    LastUsrLine As Long 'to check when user stop moving
    LastUsrColumn As Long
    lastFoundiDesc As clsDesc 'result of last search
End Type

Public Type tConfig
    EnableComments As Boolean 'Comments/Code display state
    bNeverHide As Boolean 'Disable hidding the tooltip window
    bShowPartialMatchs As Boolean 'Show the last detected data instead of canceling the tooltip
    bAnimateOnShow As Boolean 'Use animation or show directly
    bStartUpTooltipPos As Long '0=Snap to editor top/right , 1=Use last
    AutoShrink As Boolean 'Shrink size to for short lines of text
    MaxTextLines As Long 'Maximum lines to enlarge to display big text
    EnableHotkeys As Boolean 'Enable custom extra keyboard functions
    TabCantSpaces As Long ' Default=4, To calculate comments
    bSearchTypelibs As Boolean 'Search for documentation in Typelibs
    bSearchOnlyBuiltIn As Boolean 'Search only in VBA(VBA6.DLL), VBRUN(MSVBVM60.DLL), VB(VB6.OLB)
    bHighLight As Boolean
    HLColor As Long
    HLPadX As Long
    HLPadY As Long
End Type


Public cDesc As New Collection
Public cVars As New Collection
Public cOwners As Collection
Public Check As typeCheck
Public Config As tConfig

'Data of module analized
Private Lines$()
Private Totlines&
Public bLearnedDone As Boolean
Public MainWindowhwnd As Long

'NO USADAS FIX-DEL
'Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
'Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWndParent As Long, ByVal hWndChildAfter As Long, ByVal lpszClass As String, ByVal lpszWindow As String) As Long
'Private m_pSubclass As IUnknown
'Const WM_KEYDOWN = &H100
'Const WM_SYSKEYDOWN = &H104
'Const WM_SYSCHAR = &H106
'Const WM_UNICHAR = &H109
'Const WM_IMEKEYDOWN = &H290
'Const WM_HOTKEY = &H312

'============================================
'Delete data from owner on all collections
'============================================
Public Sub DeleteOwner(VCM As VBIDE.CodeModule)
Dim TargetModule$, i&
Dim Desc As clsDesc, Own As clsOwner
    'sLog VBInstance.ActiveCodePane.CodeModule
    
    TargetModule$ = LCase(VCM.Name)
    
    'First clear all elements from this module
    'Clear methods/props
    For i = cDesc.Count To 1 Step -1
        Set Desc = cDesc.Item(i)
        If (Desc.Ownername = TargetModule) Then
            cDesc.Remove (i)
        End If
    Next i
    'Clear vars
    For i = cVars.Count To 1 Step -1
        Set Desc = cVars.Item(i)
        If (Desc.Ownername = TargetModule) Then
            cVars.Remove (i)
        End If
    Next i
    'Delete the owner
    For i = cOwners.Count To 1 Step -1
        Set Own = cOwners.Item(i)
        If (Own.Name = TargetModule) Then
            cOwners.Remove (i)
        End If
    Next i
    
End Sub

'================================
'Update everything in a module
'================================
Public Sub UpdateOwner(VCM As VBIDE.CodeModule)
    DeleteOwner VCM
    'Add everything again to keep updated
    LearnFullComponent VCM.Parent, True
End Sub

'==============================================================
'Learn Variables/Objects from a component (form/mod/class/etc)
'==============================================================
Public Sub LearnFullComponent(VC As VBIDE.VBComponent, Optional addToOwnerList As Boolean = True)
On Error GoTo Err:
Dim VBCM As VBIDE.CodeModule
Dim i&
Dim Ownername$, MemberName$, bModule As Boolean, bVariable As Boolean
Dim OwnerID&
Dim ScopeType As tScopeType, MemberStartLine&
Dim newDesc As clsDesc
Dim Desc$, Desc2$, ObjType$
Dim FoundInLine&
Dim Ctrl As VBControl
Dim tim!

    Set VBCM = VC.CodeModule
    If (VC.Type = vbext_ct_StdModule) Then bModule = True
    
    If (VBCM.CountOfLines = 0) Then
        Exit Sub
    End If
    
    If (addToOwnerList) Then
        Dim iOwn As New clsOwner
        iOwn.Name = LCase$(VBCM.Name)
        iOwn.CountOfDeclarationLines = VBCM.CountOfDeclarationLines
        iOwn.ObjType = VC.Type
        cOwners.Add iOwn
    End If
    
    'Name of Form/Class/Module/Etc we are analizing
    Ownername$ = LCase(VBCM.Name)
    'OwnerID& = findOwnerIDbyName(Ownername$) 'For future use replacing strings for ids

    'Update the number of lines/position
    Totlines& = VBCM.CountOfLines
    
    'Get all the lines
    Dim LineCache$(), LineProc&, LineAux$, LineTrim$
    LineCache$ = Split(VBCM.Lines(1, Totlines&), vbCrLf)
    
    'Rejoin lines wich have a _ at the end (or else CodeLocation will not match)
    tim = Timer + 0.5
    ReDim Lines$(UBound(LineCache))
    LineAux$ = ""
    For i = 0 To UBound(LineCache) - 1
        LineTrim$ = Trim(LineCache(i))
        'Split line and not a comment? -> Join
        If (Right$(LineTrim$, 2) = " _") And (Left(LineTrim$, 1) <> "'") Then
            'Dont add the line yet, add it to a aux$
            LineAux$ = LineAux$ & LineCache(i)
        Else
            'Add the line (with aux$ if got something)
            If (LineAux$ <> "") Then
                Lines$(LineProc&) = LineAux$ & LineCache(i)
                LineAux$ = ""
            Else
                Lines$(LineProc&) = LineCache(i)
            End If
            LineProc& = LineProc& + 1
        End If
        If (Timer > tim) Then
            DoEvents: tim = Timer + 0.5
        End If
    Next i
    
    'Dont waste of time. Dont care about a few empty lines at the end
    'ReDim Preserve Lines$(LineProc&)

    'Process all members
    Dim VBM As member
    For i = 1 To VBCM.Members.Count
        Set VBM = VBCM.Members(i)
'*1     DEBUG to stop on specific module.function
'        If (Ownername$ = "module2") Then
'            'If (BDEBUG) Then sLog ">module2." & VBM.Name & ", Tipo:" & VBM.Type
'            If (VBM.Name = "func2") Then
'                i = i
'            End If
'        End If
        
        If (VBM.Type = vbext_mt_Variable) Then
            'Check if variable is declared is not standard variabe (only class/uc)
            ObjType$ = CheckObjType(VBM.Name, VBM.CodeLocation - 1, VBM.CodeLocation - 1, FoundInLine&)
            'Exit if not special type
            'If (objType$ = "") Then GoTo Nexxt
            bVariable = True
            
        ElseIf (VBM.Type = vbext_mt_Const) Then
            'Ignore constants
            GoTo Nexxt
        Else
            'Its a Method/Prop/Event
            bVariable = False
            ObjType$ = CheckObjReturnType(VBM.CodeLocation - 1)
        End If
        
        'Get the name
        MemberName$ = VBM.Name
        
        'Get the scope
        If (VBM.Scope = vbext_Private) Then
            ScopeType = tpPrivate
        Else
            If (bModule) Then
                ScopeType = tpGlobal
            Else
                ScopeType = tpPublic
            End If
        End If
        
        MemberStartLine& = VBM.CodeLocation
        Desc = FindDesc(MemberStartLine& - 1)
        Desc2 = GetVBMDesc(VBM)
        
        'Now that I got all the data...
        If (bVariable) Then
            'Variable
            'If its a standard type with no description -> Dont add it
            If (ObjType$ = "") And ((Desc = "") And (Desc2 = "")) Then GoTo Nexxt
            
            Set newDesc = New clsDesc
            newDesc.MemberName = LCase(MemberName$) 'Keep all in lowercase for faster compare with typed text
            newDesc.Ownername = Ownername$
            newDesc.ScopeType = ScopeType
            newDesc.ObjType = ObjType$
            newDesc.Description = Desc
            newDesc.Description2 = Desc2
            newDesc.DataOrigin = tpVariables
            
            cVars.Add newDesc
        Else
            'Method/Prop...
            'add it to a collection only if dont have description but has a return ObjType
            '(No need to add methods without any info)
            If (Desc <> "") Or (ObjType$ <> "") Or (Desc2 <> "") Then
                Set newDesc = New clsDesc
                newDesc.MemberName = LCase(MemberName$) 'Keep lowercase for easy compare with typed text
                newDesc.Ownername = LCase(Ownername$)
                newDesc.ScopeType = ScopeType
                newDesc.ObjType = ObjType$
                newDesc.Description = Desc
                newDesc.Description2 = Desc2
                'newDesc.DataOrigin = tpMethod
                
                cDesc.Add newDesc
            End If
        
            If (Timer > tim) Then
                DoEvents: tim = Timer + 0.5
            End If
        
        End If
Nexxt:
    Next i

    Exit Sub
Err:
    sLog AddinName & " LearnFullComponent O:" & Ownername$ & " Err: " & Err.Description
End Sub

'===========================================================
'Try to get the member description from attribute procedure
'===========================================================
Private Function GetVBMDesc(VBM As VBIDE.member) As String
On Error Resume Next
    GetVBMDesc = VBM.Description
End Function

'=======================================================
'Look in ALL collections for an object/desc
'in the same order as Visual Basic
'=======================================================
'Procedure variables are checked in text passed inside Lines$ array
'Also return the clsDesc instance with the data
Public Function ReturnType(ByRef Owner$, ByRef Name$, ByRef LookFrom$, ByRef IsFunction As Boolean, ByRef iDesc) As String
    'Search Order:
    '#1 local variable (on deconstruct)
    '#2 Private variable/functions
    '#3 public variable/functions
    '#4 global variable/functions
    '#5 other typelib (on deconstruct)
    If (ReturnTypeSeach(Owner$, Name$, LookFrom$, IsFunction, iDesc, ReturnType, tpPrivate)) Then Exit Function
    If (ReturnTypeSeach(Owner$, Name$, LookFrom$, IsFunction, iDesc, ReturnType, tpPublic)) Then Exit Function
    If (ReturnTypeSeach(Owner$, Name$, LookFrom$, IsFunction, iDesc, ReturnType, tpGlobal)) Then Exit Function
End Function

'=================================================================
'Look in especific var and method collections for an object/desc
'=================================================================
'Called from ReturnType
Private Function ReturnTypeSeach(ByRef Owner$, ByRef Name$, ByRef LookFrom$, ByRef IsFunction As Boolean, ByRef iDesc, ByRef ReturnType$, ByRef SearchScope As tScopeType) As Boolean
Dim D As clsDesc, bFound As Boolean
Dim Col As Collection
    If (IsFunction) Then
        Set Col = cDesc
    Else
        Set Col = cVars
    End If
        
    For Each D In Col
        If (D.MemberName = Name$) Then
            If (D.ScopeType = SearchScope) Then
                'Check conditions
                Select Case SearchScope
                Case tpPrivate
                    If (D.ScopeType <> tpPrivate) Then GoTo NNext
                    If (D.Ownername <> LookFrom$) Then GoTo NNext
                    If (D.Ownername <> Owner$) Then GoTo NNext
                Case tpPublic
                    If (D.ScopeType <> tpPublic) Then GoTo NNext
                    If (D.Ownername <> Owner$) Then GoTo NNext
                Case tpGlobal
                    If (D.ScopeType <> tpGlobal) Then GoTo NNext
                End Select
                ReturnType$ = D.ObjType
                Set iDesc = D
                ReturnTypeSeach = True
                Exit Function
            End If
        End If
NNext:
    Next
    
    'Failed to find in one collection, check the other
    If (IsFunction) Then
        Set Col = cVars
    Else
        Set Col = cDesc
    End If
    
    For Each D In Col
        If (D.MemberName = Name$) Then
            If (D.ScopeType = SearchScope) Then
                'Check conditions
                Select Case SearchScope
                Case tpPrivate
                    If (D.ScopeType <> tpPrivate) Then GoTo NNext2
                    If (D.Ownername <> LookFrom$) Then GoTo NNext2
                    If (D.Ownername <> Owner$) Then GoTo NNext2
                Case tpPublic
                    If (D.ScopeType <> tpPublic) Then GoTo NNext2
                    If (D.Ownername <> Owner$) Then GoTo NNext2
                Case tpGlobal
                    If (D.ScopeType <> tpGlobal) Then GoTo NNext2
                End Select
                ReturnType$ = D.ObjType
                Set iDesc = D
                ReturnTypeSeach = True
                Exit Function
            End If
        End If
NNext2:
    Next
    
End Function

'=========================================================
'Try to detect variable object type on a block of Lines$
'Ignore all standard variable types
'=========================================================
Public Function CheckObjType(ByRef LookFor$, ByRef LineStart&, ByRef LineEnd&, ByRef FoundInLine&) As String
Dim i&, aux$, lposStart&, lposEnd&, LookForVar$, LookForVarLen&, j&

    If (LineStart& < 0) Then LineStart& = 0
    If (LineEnd& < 0) Then LineEnd& = 0
    

    For i = LineStart& To LineEnd&
    
'        'DEBUG FIX-DEL
'        If (LookFor$ = "testrctest") Then
'            i = i
'        End If
    
        LookForVar$ = LookFor$ & " As "
        LookForVarLen& = Len(LookForVar$)
        'Variable. Check for multiple declarations on the same line
        lposStart& = InStr(Lines$(i), LookForVar$)
        'Fail to detect=> Exit
        If (lposStart& = 0) Then GoTo Nexxt
        
        aux$ = Mid$(Lines$(i), lposStart& + LookForVarLen&)
        'strip any more code on the same line
        lposEnd& = InStr(aux$, ",")
        If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
        lposEnd& = InStr(aux$, ":")
        If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
        lposEnd& = InStr(aux$, "'")
        If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
        'Remove the New keyword
        If (Left$(aux$, 4) = "New ") Then aux$ = Mid(aux$, 5)
        aux$ = Trim$(aux$)
        
        'Check if declared is class.xxx -> strip class
        lposStart& = InStrRev(aux$, ".")
        If (lposStart > 0) Then aux$ = Mid(aux, lposStart& + 1)
        
        Select Case aux$
        Case "String", "Long", "Single", "Boolean", "Double", "Integer", "Currency", "Byte", "Date", "Variant"
            FoundInLine& = i
            Exit Function
        Case Else
            CheckObjType = aux$
            FoundInLine& = i
            Exit Function
        End Select
    
Nexxt:
    Next i
End Function

'=========================================================
'Try to detect variable object type on a block of Lines$
'Ignore all standard variable types
'Idem CheckObjType but convert all into lowercase to match
'=========================================================
Public Function CheckObjTypeLcase(ByRef LookFor$, ByRef LineStart&, ByRef LineEnd&, ByRef FoundInLine&) As String
Dim i&, aux$, lposStart&, lposEnd&, LookForVar$, LookForVarLen&, j&
Dim lineLCase$

    LookFor$ = LCase$(LookFor$)
    LookForVar$ = LookFor$ & " as "
    LookForVarLen& = Len(LookForVar$)
    
    For i = LineStart& To LineEnd&
    
'        'DEBUG FIX-DEL
'        If (LookFor$ = "testrctest") Then
'            i = i
'        End If

        lineLCase$ = LCase(Lines$(i))
    
        'Variable. Check for multiple declarations on the same line
        lposStart& = InStr(lineLCase$, LookForVar$)
        'Fail to detect=> Exit
        If (lposStart& = 0) Then GoTo Nexxt
        aux$ = Mid$(Lines$(i), lposStart& + LookForVarLen&)
        'strip any more code on the same line
        lposEnd& = InStr(aux$, ",")
        If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
        lposEnd& = InStr(aux$, ":")
        If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
        lposEnd& = InStr(aux$, "'")
        If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
        'Remove the New keyword
        If (Left$(aux$, 4) = "New ") Then aux$ = Mid(aux$, 5)
        aux$ = Trim$(aux$)
        
        Select Case aux$
        Case "String", "Long", "Single", "Boolean", "Double", "Integer", "Currency", "Byte", "Date", "Variant"
            FoundInLine& = i
            Exit Function
        Case Else
            CheckObjTypeLcase = aux$
            FoundInLine& = i
            Exit Function
        End Select

Nexxt:
    Next i
End Function


'====================================================
'Try to detect FUNCTION return type on declaration Lines$
'Ignore all standard variable types
'====================================================
Private Function CheckObjReturnType(ByRef LineStart&) As String
Dim i&, aux$, lposStart&, lposEnd&, LookForVar$, LookForVarLen&
    
    'TODO: Process multiline declarations
    
    i = LineStart&
    LookForVar$ = ") As "
    LookForVarLen& = Len(LookForVar$)
    'Variable. Check for return type declaration
    lposStart& = InStr(Lines$(i), LookForVar$)
    'Fail to detect=> Exit
    If (lposStart& = 0) Then Exit Function
    aux$ = Mid$(Lines$(i), lposStart& + LookForVarLen&)
    'Strip any code at the end
    lposEnd& = InStr(aux$, ":")
    If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
    lposEnd& = InStr(aux$, "'")
    If (lposEnd& > 0) Then aux$ = Left$(aux$, lposEnd& - 1)
    'Remove the New keyword
    If (Left$(aux$, 4) = "New ") Then aux$ = Mid(aux$, 5)
    aux$ = Trim$(aux$)
    
    Select Case aux$
    Case "String", "Long", "Single", "Boolean", "Double", "Integer", "Currency", "Byte", "Date", "Variant"
        Exit Function
    Case Else
        CheckObjReturnType = aux$
        Exit Function
    End Select
End Function



'====================================================
'Look for description in the related typelibs
'====================================================
'Return objClass and all data found in iClsDesc
Public Function SearchTypeLib(ByVal LookFor$, ByRef iClsDesc As clsDesc, ByRef OwnerClass$) As String
On Error GoTo SKIP
Dim vRef As VBIDE.Reference
Dim PathToLib$
Dim lpos&, lExtPos&, auxLen&, extension$, File$
    
    For Each vRef In VBInstance.ActiveVBProject.References
        If (vRef.Type = vbext_rk_TypeLib) And Not (vRef.IsBroken) Then
            'Skip not builtin librarys
            If ((Config.bSearchOnlyBuiltIn) And Not (vRef.BuiltIn)) Then GoTo SKIP
            'If (BDEBUG) Then sLog vRef.IsBroken & "|" & vRef.Name & "|" & vRef.BuiltIn & "|" & vRef.FullPath
            File$ = vRef.FullPath
            'Look inside the typelib
            If (AnalyzeTypeLib(File$, LookFor$, iClsDesc, OwnerClass$)) Then
                SearchTypeLib = iClsDesc.ObjType
                Exit Function
            End If
        End If
SKIP:
    Next
End Function

'===============================================================
'Check inside the typelib for 'LookFor' and try to return the
'description in iClsDesc
'===============================================================
'Called from SearchTypeLibDesc
Private Function AnalyzeTypeLib(ByVal sTypeLibFile$, ByVal LookFor$, ByRef iClsDesc As clsDesc, ByRef OwnerClass$) As Boolean
On Error GoTo Err:
Dim s1$, s2$, s3$, s4$
Dim l1&, l2&, b1 As Boolean, b2 As Boolean
Dim i1 As Integer

    Dim tliTypeInfo As TypeInfo
    'Load the typelib data
    Dim tliTypeLibInfo As TLI.TypeLibInfo
    Set tliTypeLibInfo = New TypeLibInfo
    tliTypeLibInfo.ContainingFile = sTypeLibFile$
    
    'Check if this typelib got info on what we look for. If not -> exit
    Dim bFound As Boolean
    Dim OldLookFor$
    OldLookFor$ = LookFor$
    bFound = tliTypeLibInfo.CaseMemberName(LookFor$, tliStAll)
    If Not (bFound) Then
        'Check if its a typeinfo and return the correct case
        If (OldLookFor$ <> LookFor$) Then
            'Return the info
            Set iClsDesc = New clsDesc
            iClsDesc.Ownername = tliTypeLibInfo.Name
            iClsDesc.MemberName = LookFor$
            For Each tliTypeInfo In tliTypeLibInfo.TypeInfos
                If (tliTypeInfo.Name = LookFor$) Then
                    iClsDesc.Description = tliTypeInfo.HelpString
                    Exit For
                End If
            Next
            iClsDesc.Description2 = "File: " & sExtraeFilename(sTypeLibFile$)
            iClsDesc.DataOrigin = tpTypelib
            iClsDesc.ObjType = LookFor$
            
            AnalyzeTypeLib = True
            Exit Function
        End If
        Exit Function
    End If
    
    Dim MInfo As MemberInfo
    Dim lSearchData As Long

    'NOTE: Not optimal way to look for description but needed to make it this way
    'cause all the direct searchs failed to work (produced errors)
    
    If (OwnerClass$ <> "") Then
        lSearchData = tliTypeLibInfo.MakeSearchData(OwnerClass$, tliStAll)
        On Error Resume Next
        Set MInfo = tliTypeLibInfo.GetMemberInfo(lSearchData, INVOKE_UNKNOWN, -1, LookFor$)
        If Not (MInfo Is Nothing) Then
            'Return the info
            Set iClsDesc = New clsDesc
            iClsDesc.Ownername = OwnerClass$
            iClsDesc.MemberName = LookFor$
            iClsDesc.Description = MInfo.HelpString
            iClsDesc.DataOrigin = tpTypelib
            
            AnalyzeTypeLib = True
            Exit Function
        End If
        
        On Error GoTo Err:
    Else
        'No owner specified, try with every TypeInfo
        For Each tliTypeInfo In tliTypeLibInfo.TypeInfos
            Select Case tliTypeInfo.TypeKind
            Case TKIND_MODULE, TKIND_ENUM
                
                If (tliTypeInfo.Members.Count > 0) Then
                    On Error Resume Next
                    lSearchData = tliTypeLibInfo.MakeSearchData(tliTypeInfo.Name, tliStAll)
                    If (Err.Number = 0) Then
                        Set MInfo = tliTypeLibInfo.GetMemberInfo(lSearchData, INVOKE_UNKNOWN, -1, LookFor$)
                        If Not (MInfo Is Nothing) Then
                            'Return the info
                            Set iClsDesc = New clsDesc
                            iClsDesc.Ownername = tliTypeInfo.Name
                            iClsDesc.MemberName = LookFor$
                            iClsDesc.Description = MInfo.HelpString
                            iClsDesc.DataOrigin = tpTypelib
                            
                            AnalyzeTypeLib = True
                            Exit Function
                        End If
                    Else
                        Err.Clear
                    End If
                End If
            End Select
            
        Next
    End If

    Exit Function
Err:
    'sLog "SearchTypeLibDesc Err: " & Err.Description
End Function


'==================================================
'Look for a variable in the current procedure
'passing a varname and line number
'If found return the object type and a clsDesc
'with the description
'==================================================
Public Function LookforLocalType(Var$, CurrentLine&, ByRef iClsDesc As clsDesc) As String
On Error GoTo Err:
Dim ProcName$, ProcKind As vbext_ProcKind, startLine&, endLine&, FoundInLine&
Dim ProperCase$
Dim lpos&
Dim laux&
Dim VCM As VBIDE.CodeModule
    Set VCM = VBInstance.ActiveCodePane.CodeModule
    If (VCM Is Nothing) Then Exit Function
    

    'We ommit searching for let/get/set to speedup
    ProcKind = vbext_pk_Proc
    
    ProcName$ = VCM.ProcOfLine(CurrentLine&, ProcKind)
    
    'Not inside procedure.
    If (ProcName$ = "") Then Exit Function
    
    startLine& = VCM.ProcBodyLine(ProcName$, ProcKind)
    
    'Sometimes ProcOfLine give bad information
    'current procedure cant be below current line
    If (startLine& > CurrentLine&) Then Exit Function
    
    If (CurrentLine& - startLine& = 0) Then laux& = 1
    
    Lines$ = Split(VCM.Lines(startLine&, CurrentLine& - startLine& + laux&), vbCrLf)
    
    LookforLocalType = CheckObjTypeLcase(Var$, 1, (CurrentLine& - startLine&) - 1, FoundInLine&)
    
    If (FoundInLine& > 0) Then
        'Take the correct case from the declaration line
        lpos = InStr(LCase(Lines$(FoundInLine)), Var$)
        ProperCase$ = Mid$(Lines$(FoundInLine), lpos, Len(Var$))
        
        Set iClsDesc = New clsDesc
        iClsDesc.Ownername = ProcName$ 'LCase(ProcName$)
        iClsDesc.MemberName = ProperCase$ 'LCase(ProcName$)
        iClsDesc.Description = FindDesc(FoundInLine&)
        iClsDesc.ObjType = LookforLocalType
        iClsDesc.DataOrigin = tpLocal
    End If
    
    Exit Function
Err:
    sLog "LookforLocalType Err: " & Err.Description
End Function


'================================================
'Find description of declarations as text (if any)
'================================================
Private Function FindDesc(ByVal startLine&) As String
Dim i&, ContLines&, buffsize&
Dim s$(), Desc$, bSkipDivider As Boolean

    'Sanity check
    If (startLine& < 1) Then Exit Function
    
    On Error GoTo IgnoreInline
    'Check for inline doc  (like: "Dim gCounter as long 'Count time since blablabla" )
    i = InStr(Lines$(startLine&), "'")
    If (i > 0) Then
        'Just take the inline comment and exit cause the upper line can be
        'a common declaration we dont want
        'Ex
        ''Player position   <--- we dont want to process this
        'private x as long ' x axis
        'private speed as long ' current speed (whithout turbo)
        Desc$ = Trim(Mid(Lines$(startLine&), i + 1))
        FindDesc = Desc$
        Exit Function
        
        'This is to get everything
        's$(0) = Trim(Mid(Lines$(StartLine&), i + 1))
        'ContLines& = ContLines& + 1
        
    End If
    
IgnoreInline:
    On Error GoTo Err:
    'Early exit if there is no comment on the 1st line up the Method definition
    startLine& = startLine& - 1
    If (Left(Lines$(startLine&), 1) <> "'") Then Exit Function
    
    ReDim s$(10) 'Reserve at least x rows for comments
    i = startLine&: buffsize = 10
    
    'If the first line is something like "'==============="
    'we skip it and set to skip the topmost if its another divider
    If (IsDivider(Lines$(i))) Then
        i = i - 1
        bSkipDivider = True
    End If
    'Keep adding all comment lines
    Do
        s$(ContLines&) = Lines$(i)
        
        If (ContLines& = buffsize) Then
            buffsize = buffsize + 10
            ReDim Preserve s$(buffsize)
        End If
       
        ContLines& = ContLines& + 1
        i = i - 1
        If (i < 1) Then Exit Do
    Loop While ((Left(Lines$(i), 1) = "'"))
    
    'Remove the last line (wich is the topmost) if its a divider
    'only do this if the latest one was a divider too
    If (bSkipDivider) Then
        If (IsDivider(s$(ContLines& - 1))) Then ContLines& = ContLines& - 1
    End If
    
    'now create the description in reverse order
    For i = (ContLines& - 1) To 0 Step -1
        If (Desc$ <> "") Then
            Desc$ = Desc$ & vbCrLf & StripFirstChar(s$(i))
        Else
            Desc$ = Desc$ & StripFirstChar(s$(i))
        End If
    Next i
    FindDesc = Desc$
    Exit Function
Err:
    sLog "FindDesc Err: " & Err.Description
End Function

'===========================================
'detect lines with all the same characters
'===========================================
Private Function IsDivider(ByRef s$) As Boolean
On Error GoTo Err:
Dim c$, B$
    If (Len(s$) < 2) Then IsDivider = False: Exit Function
    B$ = Replace(s$, " ", "")
    c$ = Mid(B$, 2, 1)
    B$ = Replace(B$, c$, "")
    If (Len(B$) < 2) Then IsDivider = True
Err:
End Function

'Delete first char
Private Function StripFirstChar(ByRef s$) As String
    If (s$ = "") Then Exit Function
    StripFirstChar = Right$(s$, Len(s$) - 1)
End Function


'=========================================
'Search Owner instance by owner name
'=========================================
Public Function findOwnerInstByName(ByVal findOwner$) As clsOwner
Dim iCO As clsOwner
    findOwner$ = LCase(findOwner$)
    For Each iCO In cOwners
        If (iCO.Name = findOwner) Then
            Set findOwnerInstByName = iCO
            Exit Function
        End If
    Next
End Function

'=========================================
'Search Owner instance by owner name
'=========================================
Public Function findOwnerInstByID(ByVal findOwnerID&) As clsOwner
On Error GoTo Err:
    findOwnerInstByID = cOwners.Item(findOwnerID&)
    Exit Function
Err:
    sLog "findOwnerInstByID Err: " & Err.Description
End Function

'==============================================
'Search Owner name by id (return correct case)
'==============================================
Public Function findOwnerNameByID(ByVal OwnerID&) As String
On Error GoTo Err:
Dim iCO As clsOwner
    Set iCO = findOwnerInstByID(OwnerID)
    If (iCO Is Nothing) Then Exit Function
    findOwnerNameByID = iCO.Name
    Exit Function
Err:
    sLog "findOwnerInstByIDInCol Err: " & Err.Description
End Function

'=========================================
'Search Owner instance by owner name
'=========================================
'-1=not found
Public Function findOwnerIDbyName(ByVal findOwner$) As Long
Dim iCO As clsOwner, i&
    findOwner$ = LCase$(findOwner$)
    For i = 1 To cOwners.Count
        If (LCase(cOwners.Item(i).Name) = findOwner$) Then
            findOwnerIDbyName = i
            Exit Function
        End If
    Next i
    findOwnerIDbyName = -1
End Function


'===========================================
'return correct case for Declaration Name
'===========================================
Public Function findDecCorrectCase(ByVal Owner$, ByVal member$) As String
Dim VC As VBIDE.VBComponent
Dim VBCM As VBIDE.CodeModule
Dim VBM As member
    Set VC = GetVCbyName(Owner$)
    If (VC Is Nothing) Then Exit Function
    member$ = LCase$(member$)
    'Process all members
    For Each VBM In VC.CodeModule.Members
        If (LCase(VBM.Name) = member$) Then
            findDecCorrectCase = VBM.Name
            Exit Function
        End If
    Next
End Function

'=========================================================
'return correct case for Declaration Name (ByRef version)
'=========================================================
Public Function findDecCorrectCaseByRef(ByVal Owner$, ByVal member$, ByRef CCOwner$, ByRef CCMember$) As Boolean
On Error GoTo Err:
Dim VC As VBIDE.VBComponent
Dim VBCM As VBIDE.CodeModule
Dim VBM As member
    'Failsafe, in case of error/not found return the same values in lowercase
    CCOwner$ = Owner$
    CCMember$ = member$
    
    Set VC = GetVCbyName(Owner$)
    CCOwner$ = VC.Name
    If (VC Is Nothing) Then Exit Function
    member$ = LCase$(member$)
    'Process all members
    For Each VBM In VC.CodeModule.Members
        If (LCase(VBM.Name) = member$) Then
            CCMember$ = VBM.Name
            findDecCorrectCaseByRef = True
            Exit Function
        End If
    Next
    
Err:
End Function
'===========================================
'return correct case for Owner Name
'===========================================
Public Function findOwnerCorrectCase(ByVal Owner$) As String
Dim VC As VBIDE.VBComponent
    Set VC = GetVCbyName(Owner$)
    If (VC Is Nothing) Then Exit Function
    findOwnerCorrectCase = VC.Name
End Function

'===========================================
'Devuelve el VBComponent con ese nombre
'===========================================
Public Function GetVCbyName(ByVal Owner$) As VBIDE.VBComponent
On Error GoTo Err:
Dim VC As VBIDE.VBComponent
Dim CP As VBIDE.CodePane
    
    Owner$ = LCase(Owner$)
    'For Each VC In VBInstance.VBProjects.Item(1).VBComponents
    For Each CP In VBInstance.CodePanes
        Set VC = CP.CodeModule.Parent
        If (VC.Type = vbext_ct_RelatedDocument) Or (VC.Type = vbext_ct_ResFile) Then
            'Ignore
        Else
            If (LCase(VC.CodeModule.Name) = Owner$) Then
                Set GetVCbyName = VC
                Exit Function
            End If
        End If
    Next
    Exit Function
Err:
    sLog "GetVCbyName Err: " & Err.Description
End Function

'UNUSED
'===============================================================
'Return the ID of the ObjType
' < 0 Standard types
' 0 Not found
' > 0 Forms/Clases
'===============================================================
Public Function getObjTypeID(sTypeName$) As Long
    Select Case sTypeName
    Case "String"
        getObjTypeID = -2: Exit Function
    Case "Long"
        getObjTypeID = -3: Exit Function
    Case "Single"
        getObjTypeID = -4: Exit Function
    Case "Boolean"
        getObjTypeID = -5: Exit Function
    Case "Variant"
        getObjTypeID = -11: Exit Function
    Case "Double"
        getObjTypeID = -6: Exit Function
    Case "Integer"
        getObjTypeID = -7: Exit Function
    Case "Currency"
        getObjTypeID = -8: Exit Function
    Case "Byte"
        getObjTypeID = -9: Exit Function
    Case "Date"
        getObjTypeID = -10: Exit Function
    Case Else
        getObjTypeID = findOwnerIDbyName(sTypeName$)
    End Select
End Function

'=============================================
'Return line in code for menber Name in owner
'=============================================
Public Function findMemberLine(ByVal Owner$, ByVal member$) As Long
Dim VC As VBIDE.VBComponent
Dim VBCM As VBIDE.CodeModule
Dim VBM As member
    Set VC = GetVCbyName(Owner$)
    If (VC Is Nothing) Then Exit Function
    member$ = LCase$(member$)
    'Process all members
    For Each VBM In VC.CodeModule.Members
        If (LCase(VBM.Name) = member$) Then
            findMemberLine = VBM.CodeLocation
            Exit Function
        End If
    Next
End Function



'================================================
'Open member in code editor
'If no member is passed then open the owner module
'================================================
Public Sub ShowMemberInCode(ByVal Owner$, ByVal member$)
Dim VC As VBIDE.VBComponent
Dim VBM As member
    Set VC = GetVCbyName(Owner$)
    If (VC Is Nothing) Then Exit Sub
    
    If (member$ = "") Then
        VC.CodeModule.CodePane.Show
    Else
        member$ = LCase$(member$)
        'Process all members
        For Each VBM In VC.CodeModule.Members
            If (LCase(VBM.Name) = member$) Then
                VC.CodeModule.CodePane.Show
                VC.CodeModule.CodePane.TopLine = VBM.CodeLocation
                Exit Sub
            End If
        Next
    End If

End Sub

'================================================
'Return all the code of the member
'================================================
Public Function getMemberCode(ByVal Owner$, ByVal member$) As String
Dim VC As VBIDE.VBComponent
Dim VBM As member
Dim cantLines&, initLine&
Dim lTotlines&
Dim auxs$

Dim VBCM As VBIDE.CodeModule
    
    Set VC = GetVCbyName(Owner$)
    If (VC Is Nothing) Then Exit Function
    
    member$ = LCase$(member$)
    'Process all members
    For Each VBM In VC.CodeModule.Members
        If (LCase(VBM.Name) = member$) Then
        
        
            Dim LineCache$(), LineProc&, LineAux$, LineTrim$, i&
            lTotlines& = VC.CodeModule.CountOfLines
            LineCache$ = Split(VC.CodeModule.Lines(1, lTotlines&), vbCrLf)
            'Rejoin lines wich have a _ at the end (or else CodeLocation will not match)
            ReDim Lines$(UBound(LineCache))
            LineAux$ = ""
            For i = 0 To UBound(LineCache) - 1
                LineTrim$ = Trim(LineCache(i))
                'Split line and not a comment? -> Join
                If (Right$(LineTrim$, 2) = " _") And (Left(LineTrim$, 1) <> "'") Then
                    'Dont add the line yet, add it to a aux$
                    LineAux$ = LineAux$ & LineCache(i)
                Else
                    'Add the line (with aux$ if got something)
                    If (LineAux$ <> "") Then
                        Lines$(LineProc&) = LineAux$ & LineCache(i)
                        LineAux$ = ""
                    Else
                        Lines$(LineProc&) = LineCache(i)
                    End If
                    LineProc& = LineProc& + 1
                End If
            Next i
        
            initLine& = VBM.CodeLocation - 1
            If (VBM.Type = vbext_mt_Method) Then
                cantLines& = VC.CodeModule.ProcCountLines(VBM.Name, vbext_pk_Proc)
                
                'Cant trust this info (sometimes give bad values)
                'Try to search for real end line
                For i = initLine& + 1 To initLine& + cantLines&
                    auxs$ = Left(Trim(Lines$(i)), 7)
                    If (auxs$ = "End Sub") Or (auxs$ = "End Fun") Then
                        cantLines& = i - initLine&: Exit For
                    End If
                Next i
                
            Else
                cantLines& = 0
            End If
            
            getMemberCode = ""
            For i = 0 To cantLines&
                If (getMemberCode <> "") Then getMemberCode = getMemberCode & vbCrLf
                getMemberCode = getMemberCode & Lines$(initLine& + i)
            Next i
            Exit Function
        End If
    Next

End Function

'============================================================
'Check for an form element and return the obj class
'============================================================
'Called from Deconstruct
Public Function LookforDesignerObject(Owner$, Name$, iDesc As clsDesc) As String
On Error GoTo Err:
Dim VC As VBIDE.VBComponent
Dim vCtrl As Control
Dim vcon As VBControl

    Set VC = GetVCbyName(Owner$)
    If (VC Is Nothing) Then Exit Function
    
    If (VC.Type = vbext_ct_VBForm) Or (VC.Type = vbext_ct_VBMDIForm) Or (VC.Type = vbext_ct_UserControl) Or (VC.Type = vbext_ct_PropPage) Or (VC.Type = vbext_ct_DocObject) Then
        Name$ = LCase(Name$)
        For Each vcon In VC.Designer.VBControls
            If (LCase(vcon.ControlObject.Name) = Name$) Then
                'Found
                Set iDesc = New clsDesc
                iDesc.Ownername = Owner$
                iDesc.MemberName = LCase(vcon.ControlObject.Name)
                iDesc.ObjType = vcon.ClassName 'LCase(vcon.ClassName)
                iDesc.ScopeType = tpPublic
                iDesc.DataOrigin = tpTypelib
                iDesc.Description = "Class: " & vcon.ClassName
                LookforDesignerObject = vcon.ClassName
                Exit Function
            End If
        Next
    End If
    Exit Function
Err:
End Function

'=========================================================
'Try to parse base object in text
' Cbo(8).Listitem(selecteddata&).Text => Cbo.Listitem.Text
'=========================================================
'Called from frmAddIn.TimCheckType when typing
Public Function sObjTrim(ByVal t$, StartPos&) As String
On Error GoTo Err:
Dim lpos&, i&, auxL$, auxR$, llen&, c$
Dim bInParenthesis As Boolean, OpenPar&, ClosePar&
'    Call F(4).Suma(F.Txt(1).Text, 4).Test
'12345678901234567890123456789012345678901234567890
'         11111111112222222222333333333344444444445
    auxL$ = "": auxR$ = "": OpenPar& = 0: ClosePar& = 0
    
    '<<< Trim to left
    For i = StartPos& To 1 Step -1
        'Take 1 char
        c$ = Mid$(t$, i, 1)
        If (c$ = ")") Then
            ClosePar& = ClosePar& + 1
        ElseIf (c$ = "(") Then
            OpenPar& = OpenPar& + 1
            'Detect (< limit
            If (OpenPar& > ClosePar&) Then Exit For
        ElseIf (OpenPar& = ClosePar&) Then
            If (c$ = " ") Or (c$ = ",") Then Exit For
            auxL$ = c$ & auxL$
        End If
    Next i

    '>>> Trim to right
    llen& = Len(t$): OpenPar& = 0: ClosePar& = 0
    For i = StartPos& + 1 To llen&
        'Take 1 char
        c$ = Mid$(t$, i, 1)
        If (c$ = ")") Then
            ClosePar& = ClosePar& + 1
            'Detect >) limit
            If (OpenPar& < ClosePar&) Then Exit For
        ElseIf (c$ = "(") Then
            OpenPar& = OpenPar& + 1
        ElseIf (OpenPar& = ClosePar&) Then
            If (c$ = " ") Or (c$ = ",") Then Exit For
            auxR$ = auxR$ & c$
        End If
    Next i

    sObjTrim = Trim(auxL$ & auxR$)
    Exit Function
Err:
    Debug.Print "sObjTrim Err: " & Err.Description
End Function

'=============================================================
'Try to parse base object in text
'Idem sObjTrim but not extend to the right
'=============================================================
'Called from frmAddIn.TimCheckType when selecting text
Public Function sObjTrimLeft(ByVal t$, StartPos&) As String
On Error GoTo Err:
Dim lpos&, i&, auxL$, auxR$, llen&, c$
Dim bInParenthesis As Boolean, OpenPar&, ClosePar&
'    Call F(4).Suma(F.Txt(1).Text, 4).Test
'12345678901234567890123456789012345678901234567890
'         11111111112222222222333333333344444444445
    auxL$ = "": auxR$ = "": OpenPar& = 0: ClosePar& = 0
    
    '<<< Trim to left
    For i = StartPos& - 1 To 1 Step -1
        'Take 1 char
        c$ = Mid$(t$, i, 1)
        If (c$ = ")") Then
            ClosePar& = ClosePar& + 1
        ElseIf (c$ = "(") Then
            OpenPar& = OpenPar& + 1
            'Detect (< limit
            If (OpenPar& > ClosePar&) Then Exit For
        ElseIf (OpenPar& = ClosePar&) Then
            If (c$ = " ") Or (c$ = ",") Then Exit For
            auxL$ = c$ & auxL$
        End If
    Next i

    '>>> Trim to right
    llen& = Len(t$): OpenPar& = 0: ClosePar& = 0
    For i = StartPos& To llen&
        'Take 1 char
        c$ = Mid$(t$, i, 1)
        If (c$ = " ") Or (c$ = ",") Or (c$ = "(") Or (c$ = ")") Or (c$ = ".") Then Exit For
        auxR$ = auxR$ & c$
    Next i

    sObjTrimLeft = Trim(auxL$ & auxR$)
    Exit Function
Err:
    sLog "sObjTrimLeft Err: " & Err.Description
End Function

'=========================================================
'Replace full same chars in line with less characters
'to fit better on the display
'=========================================================
'Note: Owner must have already set the same font
'Called from frmTooltip.ShowDesc
Public Function filterCharsLine(s$, MaxWidth&, fOwner As Form) As String
Dim v As Variant, aux$
Dim i&, j&, llen&, c$, cWidth&

    'Remove scrollbar width
    MaxWidth& = MaxWidth& - (16 * Screen.TwipsPerPixelX)

    v = Split(s$, vbCrLf)
    For j = 0 To UBound(v)
        'Avoid to process lines with few chars
        llen = Len(v(j))
        If (llen > 20) Then
            cWidth = fOwner.TextWidth(v(j))
            If (cWidth > MaxWidth) Then
                aux$ = v(j)
                i = llen - 1
                'take last char
                c$ = Right(aux$, 1)
                'Repeat until we removed enough chars
                Do While (cWidth > MaxWidth)
                    'if last char is repeated remove it
                    If (Mid(aux$, i, 1) = c$) Then
                        aux$ = Left(aux$, Len(aux$) - 1)
                        i = i - 1
                        cWidth = fOwner.TextWidth(aux$)
                    Else
                        'No repeating chars.We cant shrink the line
                        cWidth = 0
                    End If
                Loop
                v(j) = aux$
            End If
            
        End If
    Next j
    
    'Recreate the string
    For j = 0 To UBound(v)
        If (j > 0) Then
            filterCharsLine = filterCharsLine & vbCrLf & v(j)
        Else
            filterCharsLine = v(j)
        End If
    Next j
    Exit Function
Err:
    sLog "filterCharsLine Err: " & Err.Description
End Function


'==================================
'Load Configuration
'==================================
Public Sub LoadConfig()

    Config.EnableComments = CBool(GetSetting(App.Title, "Settings", "EnableComments", True))
    Config.bShowPartialMatchs = CBool(GetSetting(App.Title, "Settings", "bShowPartialMatchs", False))
    Config.bAnimateOnShow = CBool(GetSetting(App.Title, "Settings", "bShowPartialMatchs", False))
    Config.bNeverHide = CBool(GetSetting(App.Title, "Settings", "bShowPartialMatchs", False))
    Config.bStartUpTooltipPos = Val(GetSetting(App.Title, "Settings", "bStartUpTooltipPos", 0))
    Config.AutoShrink = CBool(GetSetting(App.Title, "Settings", "AutoShrink", True))
    Config.MaxTextLines = Val(GetSetting(App.Title, "Settings", "MaxTextLines", 5))
    Config.EnableHotkeys = CBool(GetSetting(App.Title, "Settings", "EnableHotkeys", True))
    Config.TabCantSpaces = Registry_Read("HKEY_CURRENT_USER\Software\Microsoft\VBA\Microsoft Visual Basic\", "TabWidth", 4)
    Config.bSearchTypelibs = CBool(GetSetting(App.Title, "Settings", "bSearchTypelibs", True))
    Config.bSearchOnlyBuiltIn = CBool(GetSetting(App.Title, "Settings", "bSearchOnlyBuiltIn", False))
    
    Config.HLColor = GetSetting(App.Title, "Settings", "HLColor", vbYellow)
    Config.HLPadX = GetSetting(App.Title, "Settings", "HLPadX", 0)
    Config.HLPadY = GetSetting(App.Title, "Settings", "HLPadY", 0)
    Config.bHighLight = CBool(GetSetting(App.Title, "Settings", "bHighLight", True))
        Call frmAddIn.EnableHighLight(Config.bHighLight)
End Sub

Public Sub SaveConfig()

    SaveSetting App.Title, "Settings", "EnableComments", CStr(Config.EnableComments)
    SaveSetting App.Title, "Settings", "bShowPartialMatchs", CStr(Config.bShowPartialMatchs)
    SaveSetting App.Title, "Settings", "bAnimateOnShow", CStr(Config.bAnimateOnShow)
    SaveSetting App.Title, "Settings", "bNeverHide", CStr(Config.bNeverHide)
    SaveSetting App.Title, "Settings", "bStartUpTooltipPos", CStr(Config.bStartUpTooltipPos)
    SaveSetting App.Title, "Settings", "AutoShrink", CStr(Config.AutoShrink)
    SaveSetting App.Title, "Settings", "MaxTextLines", CStr(Config.MaxTextLines)
    SaveSetting App.Title, "Settings", "EnableHotkeys", CStr(Config.EnableHotkeys)
    'SaveSetting App.Title, "Settings", "TabCantSpaces", CStr(Config.TabCantSpaces)
    SaveSetting App.Title, "Settings", "bSearchTypelibs", CStr(Config.bSearchTypelibs)
    SaveSetting App.Title, "Settings", "bSearchOnlyBuiltIn", CStr(Config.bSearchOnlyBuiltIn)
    
    SaveSetting App.Title, "Settings", "bHighLight", CStr(Config.bHighLight)
    SaveSetting App.Title, "Settings", "HLColor", CStr(Config.HLColor)
    SaveSetting App.Title, "Settings", "HLPadX", CStr(Config.HLPadX)
    SaveSetting App.Title, "Settings", "HLPadY", CStr(Config.HLPadY)

End Sub

'For debug
Public Sub sLog(s$, Optional bClear As Boolean = False)
'    s$ = Now & "(" & Timer & ") " & s$
'    If (bClear) Then frmConfig.Text1.Text = ""
'    If (s$ = "") Then Exit Sub
'    If (frmConfig.Text1.Text <> "") Then s$ = vbCrLf & s$
'    frmConfig.Text1.Text = frmConfig.Text1.Text & s$
End Sub
