Attribute VB_Name = "ModMain"
Option Explicit

'Colors
Public cColorText&, cColorComment&, cColorSubs, cColorCodeFold&
Public cColorMark1&, cColorMark2&, cColorMark3&, cColorMark4FullRow&
Public cColorMarkTodo&, cColorProcHL&

'new
Public cColorBackcolor&, cColorLineNumber&, cColorProcedure&, cColorBackground&
Public bCfgEnableLineNumber As Boolean
Public bCfgEnableProcHiglight As Boolean
Public bCfgEnableButtonAtMenuLvl As Boolean
Public bCfgEnableSelHiglight As Boolean

Public FoldedStorageHeader$, FoldedStorageFooter$

Public mUserDoc As UserDoc

Public Sub LoadDefaults()

    'Options
    bCfgEnableLineNumber = True
    bCfgEnableProcHiglight = True
    bCfgEnableButtonAtMenuLvl = True
    bCfgEnableSelHiglight = True
    
    'Colors
    cColorMark1& = RGB(200, 0, 0)  ' Red
    cColorMark2& = RGB(200, 200, 0) 'Yellow
    cColorMark3& = RGB(0, 200, 200)  'Cyan
    cColorMark4FullRow& = RGB(200, 100, 200)
    cColorMarkTodo& = RGB(0, 255, 0) 'Green
    cColorProcedure& = vbYellow
    
    cColorBackground& = vbBlack
    cColorSubs = RGB(175, 175, 175) ' light grey
    cColorText = RGB(100, 100, 100) ' grey
    cColorComment = RGB(0, 78, 0)    ' light Green
    cColorLineNumber& = &H60FFFF 'Light yellow
    cColorProcHL& = &HA0A020
    
    cColorCodeFold& = &H557777 'RGB(200, 100, 200)
    
    Dim default$, tmp$, v As Variant
    'First line of Header
    default$ = "'\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/"
    tmp$ = Registry_Read("HKEY_CURRENT_USER\Software\VB and VBA Program Settings\CodeFold\Settings\", "FoldedStorageHeader", default$)
    v = Split(tmp$, vbCrLf)
    FoldedStorageHeader$ = v(0) 'Registry_Read("HKEY_CURRENT_USER\Software\VB and VBA Program Settings\CodeFold\Settings\", "FoldedStorageHeader", default$)
    'Last line of footer
    default$ = "'/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\"
    tmp$ = Registry_Read("HKEY_CURRENT_USER\Software\VB and VBA Program Settings\CodeFold\Settings\", "FoldedStorageFooter", default$)
    v = Split(tmp$, vbCrLf)
    FoldedStorageFooter$ = v(UBound(v))
    
End Sub


'==================================
'Save Configuration
'==================================
Public Sub SaveConfig()
On Error Resume Next

    SaveSetting App.Title, "Settings", "bCfgEnableLineNumber", CStr(bCfgEnableLineNumber)
    SaveSetting App.Title, "Settings", "bCfgEnableProcHiglight", CStr(bCfgEnableProcHiglight)
    SaveSetting App.Title, "Settings", "bCfgEnableButtonAtMenuLvl", CStr(bCfgEnableButtonAtMenuLvl)
    SaveSetting App.Title, "Settings", "bCfgEnableSelHiglight", CStr(bCfgEnableSelHiglight)

    'Colors
    SaveSetting App.Title, "Settings", "cColorMark1", CStr(cColorMark1)
    SaveSetting App.Title, "Settings", "cColorMark2", CStr(cColorMark2)
    SaveSetting App.Title, "Settings", "cColorMark3", CStr(cColorMark3)
    SaveSetting App.Title, "Settings", "cColorMark4FullRow", CStr(cColorMark4FullRow)
    SaveSetting App.Title, "Settings", "cColorMarkTodo", CStr(cColorMarkTodo)
    SaveSetting App.Title, "Settings", "cColorProcedure", CStr(cColorProcedure)
    
    SaveSetting App.Title, "Settings", "cColorBackground", CStr(cColorBackground)
    SaveSetting App.Title, "Settings", "cColorSubs", CStr(cColorSubs)
    SaveSetting App.Title, "Settings", "cColorText", CStr(cColorText)
    SaveSetting App.Title, "Settings", "cColorComment", CStr(cColorComment)
    SaveSetting App.Title, "Settings", "cColorLineNumber", CStr(cColorLineNumber)
    SaveSetting App.Title, "Settings", "cColorProcHL", CStr(cColorProcHL)

End Sub

'==================================
'Load Configuration
'==================================
Public Sub LoadConfig()
On Error Resume Next

    bCfgEnableLineNumber = CBool(GetSetting(App.Title, "Settings", "bCfgEnableLineNumber", True))
    bCfgEnableProcHiglight = CBool(GetSetting(App.Title, "Settings", "bCfgEnableProcHiglight", True))
    bCfgEnableButtonAtMenuLvl = CBool(GetSetting(App.Title, "Settings", "bCfgEnableButtonAtMenuLvl", True))
    bCfgEnableSelHiglight = CBool(GetSetting(App.Title, "Settings", "bCfgEnableSelHiglight", True))

    cColorMark1 = GetSetting(App.Title, "Settings", "cColorMark1", RGB(200, 0, 0)) ' Red
    cColorMark2 = GetSetting(App.Title, "Settings", "cColorMark2", RGB(200, 200, 0)) ' Yellow
    cColorMark3 = GetSetting(App.Title, "Settings", "cColorMark3", RGB(0, 200, 200)) ' Cyan
    cColorMark4FullRow = GetSetting(App.Title, "Settings", "cColorMark4FullRow", RGB(200, 100, 200))
    cColorMarkTodo = GetSetting(App.Title, "Settings", "cColorMarkTodo", RGB(0, 255, 0)) ' Green
    cColorProcedure = GetSetting(App.Title, "Settings", "cColorProcedure", vbYellow)

    cColorBackground = GetSetting(App.Title, "Settings", "cColorBackground", vbBlack) ' light grey
    cColorSubs = GetSetting(App.Title, "Settings", "cColorSubs", RGB(175, 175, 175)) ' grey
    cColorText = GetSetting(App.Title, "Settings", "cColorText", RGB(100, 100, 100)) ' light Green
    cColorComment = GetSetting(App.Title, "Settings", "cColorComment", RGB(0, 78, 0)) ' light Green
    cColorLineNumber& = GetSetting(App.Title, "Settings", "cColorLineNumber&", &H60FFFF)
    cColorProcHL& = GetSetting(App.Title, "Settings", "cColorProcHL&", &HA0A020)
End Sub


Public Function Registry_Read(Key_Path$, Key_Name$, Optional DefaultValue As Variant = "") As Variant
On Error GoTo Def:
    If (Right$(Key_Path$, 1) <> "\") Then Key_Path$ = Key_Path$ & "\"
    Dim Registry As Object
    Set Registry = CreateObject("WScript.Shell")
    Registry_Read = Registry.RegRead(Key_Path & Key_Name)
    Exit Function
Def:
    Registry_Read = DefaultValue
End Function
