Attribute VB_Name = "modFade"
Option Explicit

'--ApiWait---- = al doevents pero sin consumir el procesador al 100%
Private Type FileTime
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Const WAIT_ABANDONED& = &H80&
Private Const WAIT_ABANDONED_0& = &H80&
Private Const WAIT_FAILED& = -1&
Private Const WAIT_IO_COMPLETION& = &HC0&
Private Const WAIT_OBJECT_0& = 0
Private Const WAIT_OBJECT_1& = 1
Private Const WAIT_TIMEOUT& = &H102&
Private Const INFINITE = &HFFFF
Private Const ERROR_ALREADY_EXISTS = 183&
Private Const QS_HOTKEY& = &H80
Private Const QS_KEY& = &H1
Private Const QS_MOUSEBUTTON& = &H4
Private Const QS_MOUSEMOVE& = &H2
Private Const QS_PAINT& = &H20
Private Const QS_POSTMESSAGE& = &H8
Private Const QS_SENDMESSAGE& = &H40
Private Const QS_TIMER& = &H10
Private Const QS_MOUSE& = (QS_MOUSEMOVE Or QS_MOUSEBUTTON)
Private Const QS_INPUT& = (QS_MOUSE Or QS_KEY)
Private Const QS_ALLEVENTS& = (QS_INPUT Or QS_POSTMESSAGE Or QS_TIMER Or QS_PAINT Or QS_HOTKEY)
Private Const QS_ALLINPUT& = (QS_SENDMESSAGE Or QS_PAINT Or QS_TIMER Or QS_POSTMESSAGE _
                                              Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)


Private Declare Function CreateWaitableTimer Lib "kernel32" Alias "CreateWaitableTimerA" (ByVal lpSemaphoreAttributes As Long, _
    ByVal bManualReset As Long, ByVal lpName As String) As Long
Private Declare Function OpenWaitableTimer Lib "kernel32" Alias "OpenWaitableTimerA" (ByVal dwDesiredAccess As Long, _
    ByVal bInheritHandle As Long, ByVal lpName As String) As Long
Private Declare Function SetWaitableTimer Lib "kernel32" (ByVal hTimer As Long, lpDueTime As FileTime, ByVal lPeriod As Long, _
    ByVal pfnCompletionRoutine As Long, ByVal lpArgToCompletionRoutine As Long, ByVal fResume As Long) As Long
Private Declare Function CancelWaitableTimer Lib "kernel32" (ByVal hTimer As Long)
'Declarada en otro lado tambien (dupe)
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Private Declare Function MsgWaitForMultipleObjects Lib "user32" (ByVal nCount As Long, pHandles As Long, _
    ByVal fWaitAll As Long, ByVal dwMilliseconds As Long, ByVal dwWakeMask As Long) As Long
'--ApiWait---- = al doevents pero sin consumir el procesador al 100%


Private Const GWL_EXSTYLE = (-20)
Private Const LWA_ALPHA = &H2
Private Const WS_EX_LAYERED = &H80000

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hWnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long


Public Sub FadeForm(Frm As Form, Level As Byte)
    On Error Resume Next
    Dim msg As Long
    
    msg = GetWindowLong(Frm.hWnd, GWL_EXSTYLE) Or WS_EX_LAYERED
    SetWindowLong Frm.hWnd, GWL_EXSTYLE, msg
    SetLayeredWindowAttributes Frm.hWnd, 0, Level, LWA_ALPHA
End Sub

Public Sub AnimFadeOpen(Frm As Form, Optional Step As Byte = 5)
Dim msg As Long
Dim i As Integer
    
    msg = GetWindowLong(Frm.hWnd, GWL_EXSTYLE) Or WS_EX_LAYERED
    SetWindowLong Frm.hWnd, GWL_EXSTYLE, msg
    SetLayeredWindowAttributes Frm.hWnd, 0, 0&, LWA_ALPHA
    Frm.Show
        
    Do Until i = 255
        If i + Step >= 255 Then
            SetLayeredWindowAttributes Frm.hWnd, 0, 255, LWA_ALPHA
            Exit Do
        End If
            
        i = i + Step
        SetLayeredWindowAttributes Frm.hWnd, 0, CByte(i), LWA_ALPHA
        DoEvents
        ApiWait 5
    Loop
End Sub

Public Sub AnimFadeClose(Frm As Form, Optional Step As Byte = 15)
Dim i As Integer
Dim msg&

    msg = GetWindowLong(Frm.hWnd, GWL_EXSTYLE) Or WS_EX_LAYERED
    SetWindowLong Frm.hWnd, GWL_EXSTYLE, msg
    
    i = 255
        
    Do Until i = 0
        If i - Step <= 0 Then
            SetLayeredWindowAttributes Frm.hWnd, 0, 0&, LWA_ALPHA
            Exit Do
        End If
            
        i = i - Step
        SetLayeredWindowAttributes Frm.hWnd, 0, CByte(i), LWA_ALPHA
        DoEvents
        ApiWait 5
    Loop
End Sub


'--ApiWait---- = al doevents pero sin consumir el procesador al 100%
Public Sub ApiWait(lNumberOfMiliseconds As Double)
' Genera pausa sin consumir recursos
Dim FT As FileTime
Dim lBusy As Long
Dim lRet As Long
Dim dblDelay As Double
Dim dblDelayLow As Double
Dim dblUnits As Double
Dim hTimer As Long


    hTimer = CreateWaitableTimer(0, True, App.EXEName & "Timer")


    If Err.LastDllError = ERROR_ALREADY_EXISTS Then
        ' If the timer already exists, it does n
        '     ot hurt to open it
        ' as long as the person who is trying to
        '     open it has the
        ' proper access rights.
    Else
        FT.dwLowDateTime = -1
        FT.dwHighDateTime = -1
        lRet = SetWaitableTimer(hTimer, FT, 0, 0, 0, 0)
    End If

    ' Convert the Units to nanoseconds.
    dblUnits = CDbl(&H10000) * CDbl(&H10000)
    dblDelay = CDbl(lNumberOfMiliseconds) * 10000
    ' By setting the high/low time to a nega
    '     tive number, it tells
    ' the Wait (in SetWaitableTimer) to use
    '     an offset time as
    ' opposed to a hardcoded time. If it wer
    '     e positive, it would
    ' try to convert the value to GMT.
    FT.dwHighDateTime = -CLng(dblDelay / dblUnits) - 1
    dblDelayLow = -dblUnits * (dblDelay / dblUnits - _
    Fix(dblDelay / dblUnits))


    If dblDelayLow < CDbl(&H80000000) Then
        ' &H80000000 is MAX_LONG, so you are jus
        '     t making sure
        ' that you don't overflow when you try t
        '     o stick it into
        ' the FILETIME structure.
        dblDelayLow = dblUnits + dblDelayLow
    End If

    FT.dwLowDateTime = CLng(dblDelayLow)
    lRet = SetWaitableTimer(hTimer, FT, 0, 0, 0, False)


    Do
        ' QS_ALLINPUT means that MsgWaitForMulti
        '     pleObjects will
        ' return every time the thread in which
        '     it is running gets
        ' a message. If you wanted to handle mes
        '     sages in here you could,
        ' but by calling Doevents you are lettin
        '     g DefWindowProc
        ' do its normal windows message handling
        '     ---Like DDE, etc.
        lBusy = MsgWaitForMultipleObjects(1, hTimer, False, _
        INFINITE, QS_ALLINPUT&)


        DoEvents
        Loop Until lBusy = WAIT_OBJECT_0

        ' Close the handles when you are done wi
        '     th them.
        CloseHandle hTimer
End Sub
'--- Fin ApiWait --


