Attribute VB_Name = "Module1"
Option Explicit

'Disable normal FixPalette2020 working mode and work only with the press of the button
Public Const bButtonVersion = True

Public VBInstance As VBIDE.VBE
Public FormDisplayed As Boolean

Private Declare Sub SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Const HWND_TOPMOST              As Long = -1
Private Const HWND_NOTOPMOST            As Long = -2
Private Const SWP_NOSIZE                As Long = &H1
Private Const SWP_NOMOVE                As Long = &H2
Private Const SWP_NOZORDER              As Long = &H4
Private Const SWP_NOACTIVATE            As Long = &H10
Private Const SWP_FRAMECHANGED          As Long = &H20
Private Const SWP_SHOWWINDOW            As Long = &H40
Private Const SWP_HIDEWINDOW            As Long = &H80
Private Const SWP_ASYNCWINDOWPOS        As Long = &H4000


'Private Declare Function SetWindowLong Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Const GWL_EXSTYLE As Long = (-20)
Private Const GWL_STYLE As Long = (-16)
Public Enum eWindowStyle
    WS_OVERLAPPED = &H0
    WS_POPUP = &H80000000
    WS_CHILD = &H40000000
    WS_MINIMIZE = &H20000000
    WS_VISIBLE = &H10000000
    WS_DISABLED = &H8000000
    WS_CLIPSIBLINGS = &H4000000
    WS_CLIPCHILDREN = &H2000000
    WS_MAXIMIZE = &H1000000
    WS_CAPTION = &HC00000
    WS_BORDER = &H800000
    WS_DLGFRAME = &H400000
    WS_VSCROLL = &H200000
    WS_HSCROLL = &H100000
    WS_SYSMENU = &H80000
    WS_THICKFRAME = &H40000
    WS_GROUP = &H20000
    WS_TABSTOP = &H10000
    WS_MINIMIZEBOX = &H20000
    WS_MAXIMIZEBOX = &H10000
    WS_TILED = &H0
    WS_ICONIC = &H20000000
    WS_SIZEBOX = &H40000
    WS_OVERLAPPEDWINDOW = &HCF0000
    WS_POPUPWINDOW = &H80880000
End Enum


'==============================================================
'Apply window style updates
'Return old style
'==============================================================
Public Function pSetWindowLong(ByVal lHwnd As Long, ByVal Flag As Long, Optional ByVal removeFlag As Boolean = False, Optional ByVal useExtendedStyle As Boolean = False, Optional InstantUpdate As Boolean, Optional ByVal overrideEntireLong As Boolean = False) As Long
Dim nIndex As Long, curStyle As Long
        
    If useExtendedStyle Then
        nIndex = GWL_EXSTYLE
    Else
        nIndex = GWL_STYLE
    End If
    
    curStyle = GetWindowLong(lHwnd, nIndex)
    
    If overrideEntireLong Then
        SetWindowLong lHwnd, nIndex, Flag
    Else
        If removeFlag Then
            SetWindowLong lHwnd, nIndex, curStyle And (Not Flag)
        Else
            SetWindowLong lHwnd, nIndex, curStyle Or Flag
        End If
    End If
    
    'For some reason dont work properly without the DoEvents if needed to move or operate the coordinates after we called it
    If (InstantUpdate) Then UpdateWindowStyle lHwnd: DoEvents
    
    pSetWindowLong = curStyle
    
End Function

'===============================================
'Tell a window its style changed
'to be called after a SetWindowLong when needed
'===============================================
Public Function UpdateWindowStyle(lHwnd&)
    SetWindowPos lHwnd&, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED
End Function

'======================================
' Pone en "ALWAYS ON TOP" una ventana
'======================================
Public Sub pOnTop(lHwnd&, state As Boolean, Show As Boolean)
Dim v&
    v = SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE
    If (Show) Then
        v = v Or SWP_SHOWWINDOW
    Else
        v = v Or SWP_HIDEWINDOW
    End If
    If (state = False) Then
        Call SetWindowPos(lHwnd&, HWND_NOTOPMOST, 0, 0, 0, 0, v)
    Else
        Call SetWindowPos(lHwnd&, HWND_TOPMOST, 0, 0, 0, 0, v)
    End If
End Sub

